{
  Drake Rider

  (C) 2002 Vampyre SoftWorks
  Created by :  Marek Mauder  
}	


unit Campaign;

interface

uses Windows,Classes,SysUtils,GameTypes,CONTNRS,MainGame,WinFunc;

type

TMissionInfo=class(TPersistent)
            public
             Name:string;
             MapName:string;
             BeforeInf:string;
             StartInf:string;
             Details:string;
             AfterInf:string;
             XPbonus:long;

             procedure Load(S:TStream);
             procedure Save(S:TStream);



            end;

TMInfo=TMissionInfo;

TCampMgr=class
       public
        Infos:TObjectList;
        AMission:TMInfo;

        StartInfo:string;
        EndInfo:string;

        constructor Create;
        destructor Destroy;override;

        procedure Save;
        procedure Load;

       end;




type

  TCamp_HDR = record
    ID: TChar4;
    Sp1: Dword;
    Info: TChar20;
    VerHIWORD: word;
    VerLOWORD: word;
    Size: dword;
    Sp2: Dword;
  end;




const

  Camp_EXT = '.drd';
  Camp_ID = 'DRCI';
  Camp_Info='DR CAMPAIGN INFO    ';

  Camp_HDR: TCamp_Hdr = (ID: Camp_ID;
    Sp1: Byte('@') or (5 shl 8) or (5 shl 16) or (Byte('@') shl 24);
    Info: Camp_Info; VERHIWORD: VerHi; VERLOWORD: VerLo; Size: 0;
    Sp2: Byte('@') or (5 shl 8) or (5 shl 16) or (Byte('@') shl 24)

    );



var CAMPMGR:TCampMgr;



implementation




////////////////////  TMISSION INFO

procedure TMInfo.Save(S:TStream);
begin
WriteStr(S,Name);
WriteStr(S,MapName);
WriteStr(S,BeforeInf);
WriteStr(S,AfterInf);
WriteStr(S,StartInf);
WriteStr(S,Details);
S.WriteBuffer(XPBonus,sizeof(long));

end;


procedure TMInfo.Load(S:TStream);
begin
Name:=ReadStr(S);
MapName:=ReadStr(S);
BeforeInf:=ReadStr(S);
AfterInf:=ReadStr(S);
StartInf:=ReadStr(S);
Details:=ReadStr(S);
S.ReadBuffer(XPBonus,sizeof(long));

end;



/////////////////////// TCAMP MGR

constructor TCampMgr.Create;
begin
 inherited;
 Infos:=TObjectList.Create;
end;

destructor TCampMgr.Destroy;
begin

 Infos.Free;
 inherited;
end;


procedure TCampMgr.Save;
var
  i: long;
begin
  _MS.Clear;
  _MS.WriteBuffer(Camp_Hdr, SizeOf(Camp_Hdr));
  WriteStr(_MS,StartInfo);
  WriteStr(_MS,EndInfo);

  _MS.WriteBuffer(Infos.Count, SizeOf(Infos.Count));
  for i := 0 to Infos.Count - 1 do
    begin
     TMInfo(Infos[i]).Save(_MS);
    end;

  _MS.SaveToFile(RootDir + FL_CAMP);

end;


procedure TCampMgr.Load;
var hd:TCamp_Hdr;
    O:TMInfo;
    i,cnt:long;
begin
Infos.Clear;
_MS.Clear;
_MS.LoadFromFile(RootDir + FL_CAMP);
_MS.ReadBuffer(hd,sizeof(hd));
StartInfo:=ReadStr(_MS);
EndInfo:=ReadStr(_MS);

_MS.ReadBuffer(cnt,sizeof(cnt));



for i:=0 to cnt-1 do
 begin
  O:=TMInfo.Create;
  O.Load(_MS);
  Infos.Add(O);
 end;

_MS.Clear;

end;




end.
