{
  Drake Rider

  (C) 2002 Vampyre SoftWorks
  Created by :  Marek Mauder  
}	



unit Commands;

interface

uses
  Windows, Classes,SysUtils, MainGame, GameTypes,MainWin,Wins,
   WinFunc,DirectXGraphics,EngineMain,EngineObj,Music,
   Forms,DXStuff,DXObj;


procedure DoCommand(line: string);



implementation

uses DrakeClass;

function StrToken(var S: string; Separator: Char): string;
var
  I: LongInt;
begin
  I := Pos(Separator, S);
  if I <> 0 then
  begin
    Result := Copy(S, 1, I - 1);
    Delete(S, 1, I);
  end
  else
  begin
    Result := S;
    S := '';
  end;
end;


procedure StrTokenToStrings(S: string; Separator: Char; List: TStrings);
var
  Token: string;
begin
  List.Clear;
  while S <> '' do
  begin
    Token := StrToken(S, Separator);
    List.Add(Token);
  end;
end;

function StrIsDigit(S:string):boolean;
var I:LongInt;
begin
 Result:=false;
 for I:=0 to Length(S)-1 do
  if not(S[I+1] in ['0'..'9','-','+'])then
   Exit;
 Result:=true;
end;



procedure DoCommand(line: string);
var
  List,List2: TStringList;
  i,ii: long;
  dw2,dw:dword;
  Drake:TDrakeApp;
  Done:boolean;
  D3DSD:TD3DSurface_Desc;

  function GetArg(idx: long): string;
  var i: long;
  begin
    Result := '';
    for i := 0 to List.Count - 1 do
    begin
      if (idx = 0) and (List[i] <> '') then
      begin
      Result := List[i];
      break;
      end;

      if List[i] <> '' then
        if idx > 0 then dec(idx);

    end;


  end;


  function GetCmd: string;
  begin
    Result := GetArg(0);
  end;


  procedure Invalid;
  var List:TStringList;
  begin
   List:=TStringList.Create;
   List.Add(' Invalid Call');
   List.Add(' Listing Arguments...');
   List.Add(Format('  \Command = %s',[GetArg(0)]));
   List.Add(Format('  \Arg 1 = %s',[GetArg(1)]));
   List.Add(Format('  \Arg 2 = %s',[GetArg(2)]));
   List.Add(Format('  \Arg 3 = %s',[GetArg(3)]));
   List.Add(Format('  \Arg 4 = %s',[GetArg(4)]));
   List.Add(Format('  \Arg 5 = %s',[GetArg(5)]));


   ShowMsg(List,'INVALID CALL','');

   List.Free;

  end;

  function GetPl:TPlayerInfo;
  var i:long;
  begin
   Result:=nil;
   if StrIsDigit(GetArg(1))
    then
     begin
     if StrToInt(GetArg(1))in [1..4] then
       Result:=Drake.Players[StrToInt(GetArg(1))-1];
     end
     else
      begin
       for i:=0 to MAX_PLAYERS-1 do
        if CompStr(Drake.Players[i].Name,GetArg(1))then
        Result:=Drake.Players[i];

      end;

  end;

  function GetEPl:TPlayer;
  var i,idx:long;
  begin
   Result:=nil;
   for i:=0 to MAX_PLAYERS -1 do
    if Drake.Players[i]=GetPl then
     idx:=i;

   if Drake.Engine.Players[idx]<>nil then
     Result:=Drake.Engine.Players[idx];

  end;


begin
  Drake:=TDrakeApp(App);

  List := TStringList.Create;
  StrTokenToStrings(line, ' ', List);

  if GetCmd='' then Invalid;
  Done:=false;

  if CompStr(GetCmd,'Fill')then
     begin
      Done:=true;
      if (GetArg(1)='')or(not StrIsDigit(GetArg(1)))
        then begin Invalid;Exit;end;
      GameDev.SetRenderState(D3DRS_FILLMODE,StrToInt(GetArg(1)));
     end;

  if CompStr(GetCmd,'Filter')then
     begin
      Done:=true;
      if (GetArg(1)='')or(not StrIsDigit(GetArg(1)))
        then begin Invalid;Exit;end;
      GameDev.SetTextureStageState(0,D3DTSS_MINFILTER,StrToInt(GetArg(1)));
      GameDev.SetTextureStageState(0,D3DTSS_MAGFILTER,StrToInt(GetArg(1)));

     end;

  if CompStr(GetCmd,'WorldSpeed')then
     begin
        Done:=true;
        if (GetArg(1)='')or(not StrIsDigit(GetArg(1)))
        then begin Invalid;Exit;end;
      SP_WORLD:=StrToInt(GetArg(1));
     end;



  if CompStr(GetCmd,'Engine')then
     begin
      Done:=true;
      if GetArg(1)=''
        then begin Invalid;Exit;end;
      if CompStr(GetArg(1),'StopMove')then Drake.Engine.StopMove;
      if CompStr(GetArg(1),'ResumeMove')then Drake.Engine.ResumeMove;


     end;

   if CompStrArray(GetCmd,['Quit','Exit'])then QuitGame;

   if CompStrArray(GetCmd,['ToggleFullScreen','ToggleFull'])then
   begin
   Done:=true;
   Drake.ToggleFullScreen;
   end;

    if CompStr(GetCmd,'TexMemUsage')then
     begin
        Done:=true;
        dw2:=0;
        for i:=0 to TexMgr.Textures.Count-1 do
         begin
          dw:=TDXTexture(TexMgr.Textures[I]).Tex.GetLevelCount;
          for ii:=0 to dw-1 do
           begin
           TDXTexture(TexMgr.Textures[I]).Tex.GetLevelDesc(ii,D3DSD);
           dw2:=dw2+D3DSD.Size;
           end;

           ShowMsg(Format('Tex Count: %d   Tex Memory Usage: %d kB',[TexMgr.Textures.Count,dw2 div 1024]),'TexMemUsage');



         end;


     end;


    if CompStr(GetCmd,'Map')then
     begin
        Done:=true;
        if not FileExists(ExeDir+'Data\Maps\'+GetArg(1))
         then begin ShowMsg('File not found: "'+GetArg(1)+'"' ,'INVALID CALL','');Exit;end;


      Drake.Engine.Clear;
      Drake.Engine.LoadMap(GetArg(1));
      MusMgr.PlayFile(Drake.Engine.Map.ThemeMus);
      Drake.Engine.DoTimer;
      Drake.Engine.Render;
      ShowMsg('Map loaded from : "'+ExeDir+'Data\Maps\'+GetArg(1)+'"', 'Zatek mise',
        'MOD_ENGINESTOP', true);
      Drake.AddPlayers;
      Drake.Engine.Stop;

     end;

   if CompStr(GetCmd,'Player') then
    begin
       Done:=true;
       if (GetArg(1)='')or(GetArg(2)='')
        then begin Invalid;Exit;end;

      if GetPL=nil then begin Invalid;Exit;end;

     if CompStr(GetArg(2),'AddXP') then
      begin
       if GetArg(3)<>'' then
       if  not StrIsDigit(GetArg(3)) then begin Invalid;Exit;end;

       if GetArg(3)='' then  i:=1000
       else
       i:=StrToInt(GetArg(3));

       GetPL.XP:=GetPl.XP+i;
       GetPL.TotXP:=GetPl.TotXP+i;


      end;

      if CompStr(GetArg(2),'AddHP') then
      begin
       if GetArg(3)<>'' then
       if  not StrIsDigit(GetArg(3)) then begin Invalid;Exit;end;

       if GetArg(3)='' then  i:=50
       else
       i:=StrToInt(GetArg(3));

       GetPL.HP:=GetPl.HP+i;

       if Drake.State=ST_INGAME then
        if GetEPL<>nil then
       begin

        GetEPl.MaxHP:=GetEPl.MaxHP+i;
        GetEPl.HP:=GetEPl.HP+i;

       end;


      end;


     if CompStr(GetArg(2),'AddSpd') then
      begin
       if GetArg(3)<>'' then
       if  not StrIsDigit(GetArg(3)) then begin Invalid;Exit;end;

       if GetArg(3)='' then  i:=20
       else
       i:=StrToInt(GetArg(3));

       GetPL.Speed:=GetPl.Speed+i/10;

       if Drake.State=ST_INGAME then
        if GetEPL<>nil then GetEPl.Speed:=GetEPl.Speed+i/10;


      end;


    end;


 if not Done then Invalid;

end;


end.

