{
  Drake Rider

  (C) 2002 Vampyre SoftWorks
  Created by :  Marek Mauder  
}	



unit Credits;

interface

uses Windows,SysUtils,DirectXGraphics,D3DX8,D3DFont,GameTypes,Classes,
  MainGame,GUI,DXObj,Graphics,DXStuff,WinFunc;

const
 SP_SCROLL=10;
 SP_SCAmount=1;
 SP_ImgCheck=1000;
 SP_ImgChange=4000;
 SP_FADE=1000;

type

   TCredits=class
           public
            SCrollObj:TGuiObj;
            ImgObj:TGuiObj;
            scTX,
            imTX:TDXTexture;
            BmTx:TBitmap;
            Font:TFont;
            ScrollVal:long;
            ScrollList,
            ImgList:TStringList;
            Fading:boolean;
            FIn:boolean;
            AImg:long;

            ScTimer:dword;
            ImTimer:dword;
            ImCTimer:dword;

            constructor Create(SObj,IObj:TGuiObj;SList,IList:TStringList);
            destructor Destroy;

            procedure Reset;
            procedure Update;


            end;



implementation

procedure DrawOutlinedText(Dest: TCanvas; X, Y : Integer; Text: String; SC: TColor);
var
	Backup: TColor;
begin
  with Dest do
  begin
  	Backup := Font.Color;
    Font.Color := SC;
    Brush.Style := bsClear;
  	TextOut(X + 1, Y + 1, Text);
  	TextOut(X - 1, Y + 1, Text);
  	TextOut(X - 1, Y - 1, Text);
  	TextOut(X + 1, Y - 1, Text);
    Font.Color := Backup;
  	TextOut(X, Y, Text);
  end;
end;

procedure DrawTextOutline(Dest: TCanvas; X, Y : Integer; Text: String; SC: TColor);
begin
  with Dest do
  begin
    Font.Color := SC;
    Brush.Style := bsClear;
  	TextOut(X + 1, Y + 1, Text);
  	TextOut(X - 1, Y + 1, Text);
  	TextOut(X - 1, Y - 1, Text);
  	TextOut(X + 1, Y - 1, Text);
  end;
end;





constructor TCredits.Create(SObj,IObj:TGuiObj;SList,IList:TStringList);
var i:long;
begin
 inherited Create;
 ScrollObj:=SObj;
 ImgObj:=IObj;
 ScrollList:=SList;
 ImgList:=IList;
 Font:=TFont.Create;


 BmTX:=TBitmap.Create;
 BmTx.Width:=256;
 BmTx.Height:=256;

 ScTX:=TDXTExture.Create(GameDev,'',true,$FF000001,false);
 ImTX:=TDXTExture.Create(GameDev,'',true,0,false);


 Reset;
end;

destructor TCredits.Destroy;
begin

 imTX.Free;
 scTX.Free;
 Bmtx.Free;
 inherited Destroy;
end;

procedure TCredits.Update;
var i,ii:long;
    FHeight:long;
    TW:long;
    R:TRect;
    cKey:dword;
begin

if GetTickCount>scTimer+SP_SCROLL then
with BMtx do
begin
 Canvas.Brush.Color:=0;
 Canvas.FillRect(Rect(0,0,Width,Height));
 Canvas.Font:=Font;
 i:=DT_CENTER;
 FHeight:=Canvas.TextHeight('W');

 for ii := 0 to ScrollList.Count - 1 do
    begin
      with R do
      begin
        tw:=Canvas.TextWidth(ScrollList[ii])+10;
        Left := (bmtx.Width-tw)div 2; Right := (bmtx.Width-tw)div 2+tw;
        Top := -scrollval + 0 + (ii - 1) * Fheight + 3;
        Bottom := -scrollval + 0 + FHeight + (ii - 1) * Fheight + 3;
        if (ii = ScrollList.Count - 1) and (Bottom < 0) then
        begin scrollval := -bmtx.Height-20;
        end;
      end;

   //DrawText(Canvas.Handle, PChar(ScrollList[ii]), -1, R, i);

   Canvas.Font.Color:=clYellow;
   if (R.Top+FHeight>-30)and (R.Top<Bmtx.Height+30) then
   DrawOutlinedText(Canvas,R.Left,R.Top,ScrollList[ii],clRed);

  end;


 ScTx.Tex:=nil;
 ScTx.Tex:=TexFromBmp(BmTx,$FF000000);
 ScrollObj.Texture:=ScTX;


 Inc(SCrollVal,SP_SCAmount);
 scTimer:=GetTickCount;

end;


if GetTickCount>imTimer+SP_IMGCHECK then
begin
 if (not Fading)and (GetTickCount>ImcTimer+SP_IMGCHANGE)then
  begin
   ImgObj.StartFade(false);
   Fading:=true;
   FIn:=false;

  end
 else
 if Fading and (not ImgObj.Visible)and (not FIn) then
 begin
  Inc(AImg);
  if AImg>ImgList.Count-1 then AImg:=0;
  ImTX.Tex:=nil;

 cKey:=$FF200000;

{ cKey:=0;
 if CompStr(ExtractFileExt(ImgList[AImg]),'.png')then
 cKey:=$FFFF00FF;
 }ImTX.Tex:=LoadTexture(GameDev,ImgList[AImg],D3DX_FILTER_LINEAR or D3DX_FILTER_DITHER,cKey);
 ImgObj.Texture:=ImTx;

  ImgObj.StartFade(true);
  Fading:=true;
  FIn:=true;


 end
 else
 if Fading and FIn and (not ImgObj.Fading) then
  begin
   Fading:=false;
   Imctimer:=gettickcount;

  end;

end;

end;


procedure TCredits.Reset;
var cKey:dword;
begin
 scTimer:=0;
 ImTimer:=0;
 ScrollVal:=-250;
 FIn:=false;
 Fading:=false;
 ImcTimer:=GetTickCount+SP_IMGCHANGE;
 AImg:=0;

 ImTX.Tex:=nil;
 cKey:=$FF200000;

{ cKey:=0;
 if CompStr(ExtractFileExt(ImgList[AImg]),'.png')then
 cKey:=$FFFF00FF;
}ImTX.Tex:=LoadTexture(GameDev,ImgList[AImg],D3DX_FILTER_LINEAR or D3DX_FILTER_DITHER,cKey);
 ImgObj.Texture:=ImTx;

end;


end.
