{
  Drake Rider

  (C) 2002 Vampyre SoftWorks
  Created by :  Marek Mauder  
}	


unit D3DFunc;

interface

uses Windows, Classes, DirectXGraphics, gameTypes, D3DX8, Graphics, Errors;


function CreateD3D: ID3D;
function D3DRect(x1, y1, x2, y2: long): TD3DRect;
function D3DRFromRect(R:tRect):TD3DRect;
function RGBA_GETA(rgb: TD3DColor): Byte;
function RGBA_GETR(rgb: TD3DColor): Byte;
function RGBA_GETG(rgb: TD3DColor): Byte;
function RGBA_GETB(rgb: TD3DColor): Byte;
function RGBA_MAKE(r, g, b, a: Byte): TD3DColor;
function Vec2(x,y:single):TVector2;
function Vec3(x,y,z:single):TVector3;
function RGBAToRGB(rgba:dword):dword;
function RGBToRGBA(rgb:dword):dword;
function FloatToDword(f:single):dword;


implementation

function CreateD3D: ID3D;
begin
  Result := Direct3DCreate8(D3D_SDK_VERSION);
end;


function D3DRect(x1, y1, x2, y2: long): TD3DRect;
begin
  Result.x1 := x1;
  Result.y1 := y1;
  Result.x2 := x2;
  Result.y2 := y2;

end;

function D3DRFromRect(R:TRect):TD3DRect;
begin
  Result.x1 := R.Left;
  Result.y1 := R.Top;
  Result.x2 := R.Right;
  Result.y2 := R.Bottom;
end;


function RGBA_GETA(rgb: TD3DColor): Byte;
begin
  Result := rgb shr 24;
end;

function RGBA_GETR(rgb: TD3DColor): Byte;
begin
  Result := rgb shr 16;
end;

function RGBA_GETG(rgb: TD3DColor): Byte;
begin
  Result := rgb shr 8;
end;

function RGBA_GETB(rgb: TD3DColor): Byte;
begin
  Result := rgb;
end;

function RGBA_MAKE(r, g, b, a: Byte): TD3DColor;
begin
  Result := (a shl 24) or (r shl 16) or (g shl 8) or b;
end;


function Vec2(x,y:single):TVector2;
begin
 Result.x:=x;
 Result.y:=y;

end;

function Vec3(x,y,z:single):TVector3;
begin
 Result.x:=x;
 Result.y:=y;
 Result.z:=z;

end;



function RGBAToRGB(rgba:dword):dword;
 begin
  Result:=RGB(rgba_getr(rgba), rgba_getg(rgba), rgba_getb(rgba));
 
 end;

function RGBToRGBA(rgb:dword):dword;
 begin
  Result:=D3DCOLOR_ARGB($FF,GetRValue(rgb),GetGValue(rgb),GetBValue(rgb));
 
 end;

function FloatToDword(f:single):dword;
var ps:^Single;
 begin
  new(ps);
  ps^:=f;
  Result:=pdword(ps)^;

 end;


end.
