{
  Drake Rider

  (C) 2002 Vampyre SoftWorks
  Created by :  Marek Mauder  
}	


unit DXStuff;

interface



uses
  Windows, Messages, SysUtils, Classes,Controls,
   MMSystem,Forms, DXObj,
    gameTypes,WinFunc,ContNRS,DirectXGraphics;

type


  EDirectXError = class(Exception);

  TDXForm = class(TForm)
  private
    FStoreWindow: Boolean;
    FWindowPlacement: TWindowPlacement;
    procedure WMSYSCommand(var Msg: TWMSYSCommand); message WM_SYSCOMMAND;
  protected
    procedure CreateParams(var Params: TCreateParams); override;
  public
    constructor Create(AOnwer: TComponent); override;
    destructor Destroy; override;
    procedure RestoreWindow;
    procedure StoreWindow;
  end;

  {  TCustomDXTimer  }

  TDXTimerEvent = procedure(Sender: TObject; LagCount: Integer) of object;

  TCustomDXTimer = class(TComponent)
  private
    FActiveOnly: Boolean;
    FEnabled: Boolean;
    FFrameRate: Integer;
    FInitialized: Boolean;
    FInterval: Cardinal;
    FInterval2: Cardinal;
    FNowFrameRate: Integer;
    FOldTime: DWORD;
    FOldTime2: DWORD;
    FOnActivate: TNotifyEvent;
    FOnDeactivate: TNotifyEvent;
    FOnTimer: TDXTimerEvent;
    procedure AppIdle(Sender: TObject; var Done: Boolean);
    function AppProc(var Message: TMessage): Boolean;
    procedure SetActiveOnly(Value: Boolean);
    procedure SetEnabled(Value: Boolean);
    procedure SetInterval(Value: Cardinal);
  protected
    procedure DoActivate; virtual;
    procedure DoDeactivate; virtual;
    procedure DoTimer(LagCount: Integer); virtual;
    procedure Loaded; override;
  
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
    property ActiveOnly: Boolean read FActiveOnly write SetActiveOnly;
    property Enabled: Boolean read FEnabled write SetEnabled;
    property FrameRate: Integer read FFrameRate;
    property Interval: Cardinal read FInterval write SetInterval;
    property OnActivate: TNotifyEvent read FOnActivate write FOnActivate;
    property OnDeactivate: TNotifyEvent read FOnDeactivate write FOnDeactivate;
    property OnTimer: TDXTimerEvent read FOnTimer write FOnTimer;

    procedure Initialize;
    procedure Finalize;
    procedure Resume;
    procedure Suspend;
     
  end;

  {  TDXTimer  }

  TDXTimer = class(TCustomDXTimer)
  published
    property ActiveOnly;
    property Enabled;
    property Interval;
    property OnActivate;
    property OnDeactivate;
    property OnTimer;
  end;


 TDXCursor=class
              public
               Panel:TDXPanel;

               Device:IDevice;
               Window:TWinControl;
               Dim:TPoint;
               
               constructor Create(AWin:TWinControl;APan:TDXPanel;ADim:TPoint);
               destructor Destroy;override;
               procedure Update;
               function  GetPos:TPoint;
               procedure SetPos(x,y:long);

               end;
  
TTextureMgr=class
            public
              Textures:TObjectList;
              Device:IDevice;
              
              constructor Create(ADev:IDevice);
              destructor Destroy;override;

              procedure AddTextures(List:TStringList;Tag:long=0);
              function GetTex(Name:string;Tag:long=0):TDXTexture;
              function IsTex(Name:string):boolean;
              function Find(Name:string):TDXTexture;
              function AddTex(TX:TDXTexture;Tag:long=0):TDXTexture;
              procedure RemoveTex(Name:string);overload;
              procedure RemoveTex(TX:TDXTexture);overload;
              function RemoveTag(Tag:long):long;
              function CountTag(Tag:long):long;
              
             end;



function OverlapRect(const Rect1, Rect2: TRect): Boolean;


var Cursor:TDXCursor;
    TexMgr:TTextureMgr;

implementation

function OverlapRect(const Rect1, Rect2: TRect): Boolean;
begin
  Result := (Rect1.Left < Rect2.Right) and
            (Rect1.Right > Rect2.Left) and
            (Rect1.Top < Rect2.Bottom) and
            (Rect1.Bottom > Rect2.Top);
end;



////////////////////  TTEXTUREMANAGER
constructor TTextureMgr.Create(ADev:IDevice);
begin
  inherited Create;
  Textures:=TObjectList.Create;
  Device:=ADEv;

 end;


destructor TTextureMgr.Destroy;
 begin
  Device:=nil;
  Textures.Free;
  inherited;
 end;

procedure TTextureMgr.AddTextures(List:TStringList;Tag:long);
var i:long;
begin
 for i:=0 to List.Count-1 do
  GetTex(List[i],Tag);


end;

function TTextureMgr.GetTex(Name:string;Tag:long):TDXTexture;
var TX:TDXTexture;
    cKey:dword;
begin
 Result:=nil;
 cKey:=0;
 if IsTex(Name) then Result:=Find(name)
 else 
  begin
   if CompStr('.png',ExtractFileExt(Name))then CKey:=$FFFF00FF;
   TX:=TDXTexture.Create(Device,Name,true,CKey);
   TX.Load;
   TX.Tag:=Tag;
   Textures.Add(TX);
   Result:=TX;
  end;
 
 
end;

function TTextureMgr.Find(Name:string):TDXTexture;
var i:long;
 begin
  Result:=nil;

  if not IsTex(Name)then Exit;

  for i:=0 to Textures.Count-1 do
   if CompStr(Name,TDXTexture(Textures[i]).name)
    then
     begin
      Result:=TDXTexture(Textures[i]);
      Break;
     end;

  
              
 end;

function TTextureMgr.IsTex(Name:string):boolean;
var i:long;
begin
 Result:=false;
 for i:=0 to Textures.Count-1 do
   if CompStr(Name,TDXTexture(Textures[i]).name)
    then 
     begin
      Result:=true;
      Break;
     end;

              
end;

function TTextureMgr.AddTex(TX:TDXTexture;Tag:long):TDXTexture;
begin
 TX.Tag:=Tag;
 Textures.Add(TX);
 Result:=TX;
end;

procedure TTextureMgr.RemoveTex(Name:string);
var tx:tdxtexture;
begin              
 if not Istex(Name)then Exit;
 Tx:=Find(name);
 Textures.Remove(TX);

 
end;

procedure TTextureMgr.RemoveTex(TX:TDXTexture);
begin              
 Textures.Remove(TX);
end;

function TTextureMgr.RemoveTag(Tag:long):long;
var i,ii:long;
begin
 Result:=0;
 ii := Textures.Count - 1;
    for i := 0 to ii do
      if i >= Textures.Count then
        break
      else if TDXTexture(Textures[i]).Tag=tag then
      begin
        Textures.Remove(Textures[i]);
        Inc(Result);
      end;
  
end;

function TTextureMgr.CountTag(Tag:long):long;
var i:long;
begin
 Result:=0;
 for i:=0 to Textures.Count-1 do
  if TDXTexture(Textures[i]).tag=tag then Inc(Result);

end;
             
              

  
////////////////////  TDXCURSOR

constructor TDXCursor.Create(AWin:TWinControl;APan:TDXPanel;ADim:TPoint);
begin
 inherited Create;
 Window:=AWin;
 Panel:=APan;
 Device:=Panel.Device;
 Dim:=ADim;
 Window.Cursor:=crNone;
 
end;

destructor TDXCursor.Destroy;
begin
 Panel.Free;
 inherited;
end;
               
procedure TDXCursor.Update;
var P:TPoint;
begin
P:=GetPos;
Panel.SetPos(P.X,P.Y);
Panel.Render;
end;


function TDXCursor.GetPos:TPoint;
var P:Tpoint;
    Dm:TD3DDisplayMode;
begin
 P := Window.ScreenToClient(CurPos);
 Result:=Point(((P.x)* Dim.X div Window.ClientWidth ), ((P.y) * Dim.y div Window.clientheight));
end;



procedure TDXCursor.SetPos(x,y:long);
begin
 SetCursorPos(x * Window.ClientWidth div Dim.X,y * Window.ClientHeight div Dim.Y);
end;












{  TDXForm  }

var
  SetAppExStyleCount: Integer;

constructor TDXForm.Create(AOnwer: TComponent);
var
  ExStyle: Integer;
begin
  inherited Create(AOnwer);
  Inc(SetAppExStyleCount);
  ExStyle := GetWindowLong(Application.Handle, GWL_EXSTYLE);
  ExStyle := ExStyle or WS_EX_TOOLWINDOW;
  SetWindowLong(Application.Handle, GWL_EXSTYLE, ExStyle);
end;

destructor TDXForm.Destroy;
var
  ExStyle: Integer;
begin
  Dec(SetAppExStyleCount);
  if SetAppExStyleCount=0 then
  begin
    ExStyle := GetWindowLong(Application.Handle, GWL_EXSTYLE);
    ExStyle := ExStyle and (not WS_EX_TOOLWINDOW);
    SetWindowLong(Application.Handle, GWL_EXSTYLE, ExStyle);
  end;
  inherited Destroy;
end;

procedure TDXForm.CreateParams(var Params: TCreateParams);
begin
  inherited CreateParams(Params);
  Params.ExStyle := Params.ExStyle or WS_EX_APPWINDOW;
end;

procedure TDXForm.RestoreWindow;
begin
  if FStoreWindow then
  begin
    SetWindowPlacement(Handle, @FWindowPlacement);
    FStoreWindow := False;
  end;
end;

procedure TDXForm.StoreWindow;
begin
  FWindowPlacement.Length := SizeOf(FWindowPlacement);
  FStoreWindow := GetWindowPlacement(Handle, @FWindowPlacement);
end;

procedure TDXForm.WMSYSCommand(var Msg: TWMSYSCommand);
begin
  if Msg.CmdType = SC_MINIMIZE then
  begin
    DefaultHandler(Msg);
    WindowState := wsMinimized;
  end else
    inherited;
end;

{  TCustomDXTimer  }

constructor TCustomDXTimer.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  FActiveOnly := True;
  FEnabled := True;
  Interval := 1000;
  Application.HookMainWindow(AppProc);
end;

destructor TCustomDXTimer.Destroy;
begin
  Finalize;
  Application.UnHookMainWindow(AppProc);
  inherited Destroy;
end;

procedure TCustomDXTimer.AppIdle(Sender: TObject; var Done: Boolean);
var
  t, t2: DWORD;
  LagCount, i: Integer;
begin
  Done := False;

  t := TimeGetTime;
  t2 := t-FOldTime;
  if t2>=FInterval then
  begin
    FOldTime := t;

    LagCount := t2 div FInterval2;
    if LagCount<1 then LagCount := 1;

    Inc(FNowFrameRate);

    i := Max(t-FOldTime2, 1);
    if i>=1000 then
    begin
      FFrameRate := Round(FNowFrameRate*1000/i);
      FNowFrameRate := 0;
      FOldTime2 := t;
    end;

    DoTimer(LagCount);
  end;
end;

function TCustomDXTimer.AppProc(var Message: TMessage): Boolean;
begin
  Result := False;
  case Message.Msg of
    CM_ACTIVATE:
        begin
          DoActivate;
          if FInitialized and FActiveOnly then Resume;
        end;
    CM_DEACTIVATE:
        begin
          DoDeactivate;
          if FInitialized and FActiveOnly then Suspend;
        end;
  end;
end;

procedure TCustomDXTimer.DoActivate;
begin
  if Assigned(FOnActivate) then FOnActivate(Self);
end;

procedure TCustomDXTimer.DoDeactivate;
begin
  if Assigned(FOnDeactivate) then FOnDeactivate(Self);
end;

procedure TCustomDXTimer.DoTimer(LagCount: Integer);
begin
  if Assigned(FOnTimer) then FOnTimer(Self, LagCount);
end;

procedure TCustomDXTimer.Finalize;
begin
  if FInitialized then
  begin
    Suspend;
    FInitialized := False;
  end;
end;

procedure TCustomDXTimer.Initialize;
begin
  Finalize;

  if ActiveOnly then
  begin
    if Application.Active then
      Resume;
  end else
    Resume;
  FInitialized := True;
end;

procedure TCustomDXTimer.Loaded;
begin
  inherited Loaded;
  if (not (csDesigning in ComponentState)) and FEnabled then
    Initialize;
end;

procedure TCustomDXTimer.Resume;
begin
  FOldTime := TimeGetTime;
  FOldTime2 := TimeGetTime;
  Application.OnIdle := AppIdle;
end;

procedure TCustomDXTimer.SetActiveOnly(Value: Boolean);
begin
  if FActiveOnly<>Value then
  begin
    FActiveOnly := Value;

    if Application.Active and FActiveOnly then
      if FInitialized and FActiveOnly then Suspend;
  end;
end;

procedure TCustomDXTimer.SetEnabled(Value: Boolean);
begin
  if FEnabled<>Value then
  begin
    FEnabled := Value;
    if ComponentState*[csReading, csLoading]=[] then
      if FEnabled then Initialize else Finalize;
  end;
end;

procedure TCustomDXTimer.SetInterval(Value: Cardinal);
begin
  if FInterval<>Value then
  begin
    FInterval := Max(Value, 0);
    FInterval2 := Max(Value, 1);
  end;
end;

procedure TCustomDXTimer.Suspend;
begin
  Application.OnIdle := nil;
end;



initialization

finalization

end.
