unit DrakeClass;

interface

uses
  Windows,  SysUtils, D3DFunc, MIDPlay,
  DirectXGraphics, gameTypes, WinFunc, Forms, GUI, Wins, Errors,
  D3DX8, D3DClass, MainGame, DXObj, Messages, Graphics,
  Objects, DXStuff, Enginemain, EngineObj, Sound, Music,
  VTextList, EngEquip, Campaign, KeyBoard, {D3DFont,} Credits,Classes;


type

  TPlayers = array[0..MAX_PLAYERS - 1] of TPlayerInfo;

  TMode = (gmCamp, gmMaps);

  TDrakeApp = class(TD3DApp)
  private
    Mode: TMode;


    APlayer: TPlayerInfo;

    VerFont: ID3DXFont;
//    Font3D: TD3DFont;


    Credits: TCredits;

    Editing: boolean;
    AKey: pword;
    KeyVal: word;

    AStr: pstring;
    StrVal: string;
    StrPos: long;
    ConCmd:string;

    EndGame: boolean;
    Debrief: boolean;
    Details: boolean;
  protected

    procedure SetState(Value: long); override;

  public
    Players: TPlayers;
    Engine: TEngine;

    destructor Destroy; override;
    procedure ExitGame; override;

    procedure Render; override;
    procedure RestoreObj; override;
    procedure DeleteObj; override;

    procedure SetDefaults(setdef: long); override;
    procedure MsgHandler(var Msg: TMsg; var Handled: boolean); override;
    procedure DoTimer; override;
    procedure PerformGUI(MSG: TGMSG);
    procedure DrawStats; override;

    procedure SetPList;
    procedure CheckMus(St: long);

    procedure GetString(str: pstring; capt:string='Zadej jmno';data: string = 'MOD_GETSTR');
    procedure GetKey(key: pword; data: string = 'MOD_GETKEY');

    procedure CreatePlayers;
    procedure AddPlayers;
    procedure UpdatePlayers;
    function UpdatePlImg(pl: long): TDXTexture;

    procedure MapEnd(Eng: TEngine);
    procedure StartCampaign;
    procedure NextMission;
    procedure ChangeStoryBox(List: string);
    procedure UpdateInter;
    procedure ShowDebrief;
    procedure EndCampaign;
    procedure NextMap;
    procedure CreateSnap;
    procedure ProcessEdit(Msg: TMsg);
    procedure LoadControls;
    procedure SaveControls;
    procedure ShowExitMenu;
    procedure ShowConsole;

  end;


implementation

uses MainWin,Commands;

var

  EObj: TBaseObj;
  Obj: TGuiObj;
  Win: TGuiWin;
  spTime: long;
  contime: long;
  ainited: boolean;
  aFrame: long;
  Ene: tEnemy;
  st: string;
  sList: TStringList;

destructor TDrakeApp.Destroy;
begin

  inherited;
end;

procedure TDrakeApp.ExitGame;
begin
  Timer.Enabled := false;
  SaveControls;
 //Cursor.Free;
  Credits.Free;
  Engine.Free;
  WinMgr.Free;
  MusMgr.Free;
  SoundMgr.Free;
  TexMgr.Free;
  CampText.Free;
  TextList.Free;
  ObjMgr.Free;
  CampMgr.Free;

  inherited;
end;

procedure TDrakeApp.SetDefaults(setdef: long);
var i: long;
  sr: TSearchRec;
begin
  inherited;
  case setdef of
    SD_CREATE:
      begin
        

        AddFontResource(Pchar(Exedir + 'Data\Fonts\Orea.ttf'));
        AddFontResource(Pchar(Exedir + 'Data\Fonts\Calligraphia.ttf'));

      //  Console:=TWin(Window).Console;

        GfxOpt.Width := 800;
        GfxOpt.Height := 600;
        GfxOpt.Bits := 32;
        //GfxOpt.FullScreen := true;
        GfxOpt.Handle := Window.Handle;
        GfxOpt.DepthBuffer := not false;

        GameOpt.PlayMus := true;
        GameOpt.PlaySfx := true;
        GameOpt.MusVol := 3;
        GameOpt.SfxVol := 5;
        GameOpt.RandPly := true;
        GameOpt.ClearDev := true;

        //BFGraphic := TBigFile.Create(nil, ExeDir + 'Data\Graphic.vbf');


      end;
    SD_PREINIT:
      begin
        D3DXMatrixIdentity(WorldMatrix);
        D3DXMatrixIdentity(ViewMatrix);
        D3DXMatrixOrthoOffCenterLH(ProjectMatrix, 0, GameOpt.IntWidth,
          GameOpt.IntHeight, 0, -100, 100);


      end;
    SD_AFTERINIT:
      begin
        GameServer := Self;
        GameDev := Device;
        GameWin := Window;

        SoundMgr := TSoundMgr.Create(Window.handle);
        SoundMgr.SetVol(GameOpt.SfxVol);
        if not GameOpt.PlaySfx then Soundmgr.Stop;

        MusMgr := TMusicMgr.Create;
        MusMgr.SetVol(GameOpt.MusVol);

        ObjMgr := TObjMgr.Create;
        ObjMgr.Load;

        CampMgr := TCampMgr.Create;
        CampMgr.Load;
        //MusMgr.StartPList();
        // MusMgr.PlayFile(MusMgr.List[0]);
        TexMgr := TTextureMgr.Create(Device);
        WinMgr := TGuiController.Create(Device, Point(GameOpt.IntWidth,
          GameOpt.IntHeight), PerformGUI);

        TextList := TTextList.Create(Window);
        TextList.Items.LoadFromFile(RootDir + 'Data\Text\Text.vtx');

        CampText := TTextList.Create(Window);
        CampText.Items.LoadFromFile(RootDir + 'Data\Text\Camp.vtx');


        Cursor := TDXCursor.Create(Window, TGuiObj.Create(Device, 'Cursor',
          Rect(0, 0, 48, 48), $B4FFFFFF, nil, '', true, LoadTexture(Device,
          'cursors\cursor.png', 1, $FF000000)), Point(GameOpt.IntWidth,
          GameOpt.IntHeight));
        Engine := TEngine.Create(Device, Point(GameOpt.IntWidth,
          GameOpt.IntHeight));
        Engine.OnMapEnd := MapEnd;
        Engine.SetPerf(GameOpt.GameSpeed);

        BuildWins(WinMgr);

        CreatePlayers;
        APlayer := Players[0];

        /// Font3D:=TD3DFont.Create_('Calligraphia',12,1);
        //Font3D.InitDeviceObjects(Device);
        sList := GetStrings('imgcredits');
        sList.Clear;
        if FindFirst(Rootdir + 'Data\graphic\crimg\*.*', faAnyFile, SR) = 0 then
        begin
          if CompStrArray(ExtractFileExt(sr.Name), ['.png', '.jpg']) then
            sList.Add('crimg\' + sr.Name);
          while FindNext(SR) = 0 do
            if CompStrArray(ExtractFileExt(sr.Name), ['.png', '.jpg']) then
              sList.Add('crimg\' + sr.Name);
          FindClose(sr);
        end;
        sList.SaveToFile(Rootdir + 'Data\graphic\crimg\generated.lst');

        Credits := TCredits.Create(UsedWins.scCredits,
          UsedWins.imCredits, GetStrings('credits'), sList);

        Credits.Font.Name := 'Calligraphia';
        Credits.Font.Size := 10;
        Credits.Font.Style := [fsBold];
        Credits.Font.Color := clYellow;



        spTime := GetTickCount;
        ainited := true;
      end;


  end;

end;

procedure TDrakeApp.CreatePlayers;
var i: long;
begin
  for i := 0 to MAX_PLAYERS - 1 do
    Players[i] := TPlayerInfo.Create;

  for i := 0 to MAX_PLAYERS - 1 do
    Players[i] := TPlayerInfo(ObjMgr.Find('Drake Rider').Clone);



  Players[0].Name := 'Galfar';

  Players[1].Name := 'Kyllard';
  Players[1].I_Left := Ord('A'); Players[1].I_Right := Ord('D');
  Players[1].I_Up := Ord('W'); Players[1].I_Down := Ord('S');
  Players[1].I_Fire2 := Ord('T'); Players[1].I_Fire := Ord('R');

  Players[2].Name := 'Gorgue';
  Players[2].I_Left := Ord('H'); Players[2].I_Right := Ord('K');
  Players[2].I_Up := Ord('U'); Players[2].I_Down := Ord('J');
  Players[2].I_Fire2 := Ord('P'); Players[2].I_Fire := Ord('O');

  Players[3].Name := 'Kokardeth';
  Players[3].I_Left := VK_DELETE; Players[3].I_Right := VK_NEXT;
  Players[3].I_Up := VK_HOME; Players[3].I_Down := VK_END;
  Players[3].I_Fire2 := VK_NUMPAD8; Players[3].I_Fire := VK_NUMPAD7;

  for i := 0 to MAX_PLAYERS - 1 do
    Players[i].Enabled := true;

  Players[2].Enabled := false;
  Players[3].Enabled := false;

  LoadControls;


  Players[0].ImgCol := PLColors[0];
  Players[1].ImgCol := PLColors[1];
  Players[2].ImgCol := PLColors[2];
  Players[3].ImgCol := PLColors[3];


end;

procedure TDrakeApp.AddPlayers;
var i: long;
  Pls: array[0..3] of TPlayer;
begin
  Players[0].SetPos(10, 120);
  Players[1].SetPos(10, 200);
  Players[2].SetPos(10, 280);
  Players[3].SetPos(10, 360);


  for i := 0 to MAX_PLAYERS - 1 do
  begin

    Pls[i] := TPlayer.Create(Device,
      Rect(Players[i].X, Players[i].Y, Players[i].Width, Players[i].Height),
      TexMgr.GetTex(Players[i].TexName),
      Players[i].Color, Players[i].Z, true);
    Pls[i].LoadFromInfo(Players[i]);
    Pls[i].XP := 0;

    Pls[i].Texture := UpdatePlImg(i);

    if Players[i].Enabled then
      Engine.Add(Pls[i])
    else
    begin
      Pls[i].Free; Pls[i] := nil;
    end;
  end;


  for i := 0 to 3 do
    with Engine do
    begin
      Engine.Players[i] := Pls[i];
      PlInfos[i].Visible := Self.Players[i].Enabled;
      PlNames[i].Visible := Self.Players[i].Enabled;


      PlNames[i].AddCaption(Self.Players[i].Name + ' [' + IntToStr(i + 1) + ']',
        Fonts[FN_ING], Point(0, 0));


    end;



end;

function TDrakeApp.UpdatePlImg(pl: long): TDXTexture;
var PLi: TPlayerInfo;
  TX: TDXTexture;
  itx: ITexture;
  x, y: long;
begin
  pli := Players[pl];
  itx := LoadTexture(Device, 'players\drake.png');

  Pli.Image.Free;
  Pli.Image := BMPFromTex(itx);

  TexMgr.RemoveTex('PlayerTex ' + IntToStr(pl + 1));

  for x := 0 to Pli.Image.Width do
    for y := 0 to Pli.Image.Height do
      if Pli.Image.Canvas.Pixels[x, y] = clWhite then
        Pli.Image.Canvas.Pixels[x, y] := RGBATORGB(Pli.ImgCol);

  TX := TDXTexture.Create(Device, 'PlayerTex ' + IntToStr(pl + 1), true,
    $FF000000);
  TX.Tex := TexFromBmp(Pli.Image, $FFFF00FF);
  TexMgr.AddTex(TX);

  itx := nil;
  Result := TX;

end;

procedure TDrakeApp.UpdatePlayers;
var i: long;
begin
  for i := 0 to MAX_PLAYERS - 1 do
    if Engine.Players[i] <> nil then
    begin
      Players[i].DXP := Engine.Players[i].XP + CampMgr.AMission.XPbonus;

      Players[i].XP := Players[i].XP + Players[i].DXP;
      Players[i].TotXP := Players[i].TotXP + Players[i].DXP;

      Players[i].Kills := Players[i].Kills + Engine.Players[i].Kills;
      Players[i].Deaths := Players[i].Deaths + Engine.Players[i].Deaths;


    end;


end;

procedure TDrakeApp.StartCampaign;
begin
  CampMgr.AMission := TMInfo(CampMgr.Infos[0]);
  Debrief := false;
  EndGame := false;
  State := ST_INTERGAME;

end;

procedure TDrakeApp.EndCampaign();
begin
  EndGame := true;
  with UsedWins do
  begin
    StoryBox.AddStrings(GetStrings(CampMgr.EndInfo), Fonts[FN_story], true,
      true);
    StoryWin.ToFront;
    StoryWin.StartFade(true);

  end;


end;


procedure TDrakeApp.NextMission;
var idx: long;
begin
  UpdatePlayers;
  idx := CampMgr.Infos.IndexOf(CampMgr.AMission);
  idx := idx + 1;
  if idx <= CampMgr.Infos.Count - 1 then
    CampMgr.AMission := TMInfo(CampMgr.Infos[idx])
  else
  begin
    State := ST_ENDGAME;
    Exit;
  end;
  Debrief := true;
  State := ST_INTERGAME;

end;




procedure TDrakeApp.SetState(Value: long);
var
  i: long;

begin

  with UsedWins do
    case Value of
      ST_SPLASH:
        begin
          Splash.Show;

        end;

      ST_ANILOGO:
        begin
          Splash.StartFade(false);
          AniWin.StartFade(true);
          SoundMgr.GetSnd('gui\vamp.wav').play;
          spTime := GetTickCount;
        end;


      ST_MAINMENU:
        begin
          Engine.Clear;
          CampMgr.AMission := nil;
          _B := false;
          if NGSELMODE.Visible then _B := true;
          WinMgr.HideAll;
          if _B then NGSELMODE.StartFade(false);
          if State = ST_ANILOGO then
          begin
            AniWin.StartFade(false);
            SetPList;
          end;
          if State = ST_ENDGAME then EndWin.StartFade(false);
          if State = ST_InterGAME then Intergame.StartFade(false);
          if State = ST_CREDITS then Credits.StartFade(false);


          MainMenu.StartFade(true);

        end;
      ST_NEWGAME:
        begin
          ChangeStoryBox('MainStory');

          WinMgr.HideAll;
          MainMenu.StartFade(false);
          NGSelMode.StartFade(true);

        end;
      ST_INTERGAME:
        begin
          Engine.Clear;
          UpdateInter;
          _B := false;
          //if StoryWin.Visible then _B:=true;
          WinMgr.HideAll;
          //if _B then StoryWin.StartFade(false);


          if not Debrief then
            InterGame.StartFade(true)
          else
            ShowDebrief;
          //Debrief:=false;


        end;
      ST_ENDGAME:
        begin
          EndGame := true;
          WinMgr.HideAll;
          StoryBox.AddStrings(GetStrings(CampMgr.EndInfo), Fonts[FN_story],
            true, true);
          StoryWin.StartFade(true);



        end;
      ST_INGAME:
        begin
          WinMgr.HideAll;

          Engine.LoadMap(CampMgr.AMission.MapName);
          Engine.DoTimer; Engine.Render;
          ShowMsg(GetStrings(CampMgr.AMission.StartInf), 'Zatek mise',
            'MOD_ENGINESTOP', true);
          AddPlayers;

          Engine.Stop;

        end;
      ST_CREDITS:

        begin
          WinMgr.HideAll;
          MainMenu.StartFade(false);
          Self.Credits.Reset;
          Credits.StartFade(true);
          MusMgr.IMID.PlayList.Pause;
          TBStream(SoundMgr.GetSnd('summoning.mp3', TBStream)).Play(true);


        end;

    end;
  CheckMus(Value); ;


  inherited;
end;

procedure TDrakeApp.Render;
var
  P: TPoint;
begin
  inherited;



  case State of
    ST_SPLASH: ;
    ST_INGAME: Engine.Render;
    ST_CREDITS: Credits.Update;

  end;

  WinMgr.Render;
  if (state = ST_MAINMENU) and (UsedWins.MainMenu.Visible) then
  begin
    _R := Rect(0, Window.ClientHeight - 15, 300, Window.ClientHeight);
    VerFont.DrawTextA(PChar(sVersion), -1, _R, 0, FNT_DefCol);

  end;

  //if Console.Visible then Console.PaintTo(GetDC(Window.Handle),10,10);
end;

procedure TDrakeApp.MsgHandler(var Msg: TMsg; var Handled: boolean);
begin
  WinMgr.CheckInput(Msg);

  case Msg.message of


    WM_KEYDOWN:
      begin
        if Editing and (AKey <> nil) then
        begin
          KeyVal := Msg.wParam;
          UsedWins.IEdit
            .AddCaption(VirtualKeyCodeToKeyName(KeyVal), Fonts[FN_edit],
            Point(0, 0));
        end;
        if Editing and (AStr <> nil) then
        begin
          ProcessEdit(Msg);
        end;


        case Msg.wParam of
          VK_ESCAPE:
            begin
              if state = st_ingame then ShowExitMenu;
            end;

          VK_F12: CreateSnap;

          VK_F9:
            begin
              Engine.Clear; State := ST_MAINMENU;
            end;


          $C0: ShowConsole;

          VK_F4:
            begin
              Quitgame;
            end;

        end;
      end;
  end;

end;

procedure TDrakeApp.DeleteObj;
begin
  inherited;
// Font3D.InvalidateDeviceObjects;
// Font3D.DeleteDeviceObjects;
//  Font3D.Free;

end;

procedure TDrakeApp.RestoreObj;
var
  F: TFont;
begin
  inherited;

{  Font3D := TD3DFont.Create_('Calligraphia', 12, 1);
  Font3D.InitDeviceObjects(Device);
  Font3D.RestoreDeviceObjects;
 }
  F := TFont.Create;
  F.Name := 'Calligraphia';
  F.Size := 8;
  F.Color := FNT_DefCol;
  F.Style := [fsBold];
  VerFont := nil;
  if Failed(D3DXCreateFont(Device, F.Handle, VerFont)) then
    ShowError(ERR_CREATEOBJ);

  if Engine <> nil then Engine.InfoFont := nil;

end;

procedure TDrakeApp.DoTimer;
var
  ii: string;
begin
  WinMgr.DoTimer;

  case STATE of
    ST_SPLASH:
      if GetTickCount > spTime + 1000 then State := ST_ANILOGO;

    ST_ANILOGO:
      begin
        if GetTickCount > spTime + 4000 then State := ST_MAINMENU;

      end;

    ST_INGAME:
      begin
        Engine.DoTimer;

      end;



  end;



end;

procedure TDrakeApp.DrawStats;
begin
  inherited;
  with StatsFontDX do
  begin

    case State of
      ST_INGAME:
        begin

          _R := Rect(10, 30, 190, 50);
          DrawTextA(PChar(Format('Engine Objs: %d', [Engine.Objects.Count])),
            -1, _R, 0,
            D3DCOLOR_ARGB(200, 255, 255, 50));

          _R := Rect(10, 50, 190, 70);
          DrawTextA(PChar(Format('World X: %d', [Engine.WorldX])), -1, _R, 0,
            D3DCOLOR_ARGB(200, 255, 255, 50));

          _R := Rect(10, 50 + 20, 190, 70 + 20);

        end;
    end;
  end;
end;

procedure TDrakeApp.SetPList;
begin
  if not GameOpt.PlayMus then Exit;
  if GameOpt.RandPly then
    MusMgr.StartPList
  else
    CheckMus(State);
end;

procedure TDrakeApp.CheckMus(St: long);
begin
  if not GameOpt.PlayMus then Exit;
  if not GameOpt.RandPly then
    case St of
      ST_MAINMENU: MusMgr.PlayFile('dagger.mid');
      ST_NEWGAME: MusMgr.PlayFile('ria.mid');
      ST_INTERGAME: MusMgr.PlayFile('day.mid');
      ST_ENDGAME: MusMgr.PlayFile('palace.mid');
      ST_INGAME: MusMgr.PlayFile(Engine.Map.ThemeMus);
    end;
end;


procedure TDrakeApp.MapEnd(Eng: TEngine);
var List: TStringList;
begin
  Eng.Stop;

  List := TStringList.Create;
  List.Add('Gratuluji!');
  List.Add('Mise splnna!');

  ShowMsg(List, 'MISE SPLnna', 'MOD_MAPEND', true);
  List.Free;

end;

procedure TDrakeApp.NextMap;
begin

  if Mode = gmCamp then
    NextMission

end;


procedure TDrakeApp.PerformGUI(MSG: TGMSG);

  procedure UpdateGFXopt;
  var
    Lab: TGuiObj;
    cap: string;
    w, h, b: long;
  begin
    with UsedWins do
    begin
      if GfxOpt.FullScreen then
        OptGfx.Find('CB_fullscr').Texture := TexMgr.GetTex('gui\cb_true.jpg')
      else
        OptGfx.Find('CB_fullscr').Texture := TexMgr.GetTex('gui\cb_false.jpg');


      w := GfxOpt.width;
      h := GfxOpt.height;
      b := Gfxopt.Bits;
      if not GfxOpt.FullScreen then
      begin
        w := 640;
        h := 480;
        case DeskMode.Format of
          21, 22: b := 32;
          23, 24:
            b := 16
        end;
      end;
      Cap := Format('%dx%dx%d', [w, h, b]);
      Lab := OptGfx.Find('LAB_Res');
      Lab.AddCaption(Cap, Fonts[FN_SMBTN_L], Point(0, 0));

    end;
  end;

  procedure UpdateMus;

  begin
    with UsedWins do
    begin
      if GameOpt.PlayMus then
        OptMus.Find('CB_turnmus').Texture := TexMgr.GetTex('gui\cb_true.jpg')
      else
        OptMus.Find('CB_turnmus').Texture := TexMgr.GetTex('gui\cb_false.jpg');

      if GameOpt.RandPly then
        OptMus.Find('CB_randply').Texture := TexMgr.GetTex('gui\cb_true.jpg')
      else
        OptMus.Find('CB_randply').Texture := TexMgr.GetTex('gui\cb_false.jpg');


      OptMus.Find('tb_vol_1').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      OptMus.Find('tb_vol_2').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      OptMus.Find('tb_vol_3').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      OptMus.Find('tb_vol_4').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      OptMus.Find('tb_vol_5').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      case GameOpt.MusVol of
        1: OptMus.Find('tb_vol_1').Texture := TexMgr.GetTex('gui\tb_true.jpg');
        2: OptMus.Find('tb_vol_2').Texture := TexMgr.GetTex('gui\tb_true.jpg');
        3: OptMus.Find('tb_vol_3').Texture := TexMgr.GetTex('gui\tb_true.jpg');
        4: OptMus.Find('tb_vol_4').Texture := TexMgr.GetTex('gui\tb_true.jpg');
        5: OptMus.Find('tb_vol_5').Texture := TexMgr.GetTex('gui\tb_true.jpg');
      end;
    end;

  end;

  procedure UpdateSfx;

  begin
    with UsedWins do
    begin
      if GameOpt.PlaySfx then
        Optsfx.Find('CB_turnsfx').Texture := TexMgr.GetTex('gui\cb_true.jpg')
      else
        OptSfx.Find('CB_turnsfx').Texture := TexMgr.GetTex('gui\cb_false.jpg');

      OptSfx.Find('tb_svol_1').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      OptSfx.Find('tb_svol_2').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      OptSfx.Find('tb_svol_3').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      OptSfx.Find('tb_svol_4').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      OptSfx.Find('tb_svol_5').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      case GameOpt.SfxVol of
        1: OptSfx.Find('tb_svol_1').Texture := TexMgr.GetTex('gui\tb_true.jpg');
        2: OptSfx.Find('tb_svol_2').Texture := TexMgr.GetTex('gui\tb_true.jpg');
        3: OptSfx.Find('tb_svol_3').Texture := TexMgr.GetTex('gui\tb_true.jpg');
        4: OptSfx.Find('tb_svol_4').Texture := TexMgr.GetTex('gui\tb_true.jpg');
        5: OptSfx.Find('tb_svol_5').Texture := TexMgr.GetTex('gui\tb_true.jpg');
      end;
    end;

  end;



  procedure NextPl(next: boolean = true);
  var i, idx: long;
  begin
    for i := 0 to MAX_PLAYERS - 1 do
      if Players[i] = APlayer then
      begin
        idx := i; break;
      end;

    if next then
      if idx < MAX_PLAYERS - 1 then
        inc(idx)
      else
        idx := 0;

    if not next then
      if idx > 0 then
        dec(idx)
      else
        idx := MAX_PLAYERS - 1;

    APlayer := Players[idx];


  end;

  procedure UpdateInput;
  var aplidx, i: long;
  begin
    with UsedWins do
    begin
      for i := 0 to MAX_PLAYERS - 1 do
        if APLayer = Players[i] then AplIdx := i + 1;


      OptIn.Find('Lab_actpl').AddCaption(Format(APlayer.name + ' [%d]',
        [aplidx]), Fonts[FN_MEDBTN],
        Point(0, 0));

      OptIn.Find('Lab_iup').AddCaption(VirtualKeyCodeToKeyName(APlayer.I_up),
        Fonts[FN_MEDBTN], Point(0, 0));
      OptIn.Find('Lab_idown').AddCaption(VirtualKeyCodeToKeyName(APlayer.I_down), Fonts[FN_MEDBTN], Point(0, 0));
      OptIn.Find('Lab_ileft').AddCaption(VirtualKeyCodeToKeyName(APlayer.I_left), Fonts[FN_MEDBTN], Point(0, 0));
      OptIn.Find('Lab_iright').AddCaption(VirtualKeyCodeToKeyName(APlayer.I_right), Fonts[FN_MEDBTN], Point(0, 0));
      OptIn.Find('Lab_ifire1').AddCaption(VirtualKeyCodeToKeyName(APlayer.I_fire), Fonts[FN_MEDBTN], Point(0, 0));
      OptIn.Find('Lab_ifire2').AddCaption(VirtualKeyCodeToKeyName(APlayer.I_fire2), Fonts[FN_MEDBTN], Point(0, 0));


    end;


  end;


  procedure UpdatePlayers;
  var Obj: tGuiObj;
    i, AplIdx: long;
  begin
    with UsedWins do
    begin
      for i := 0 to MAX_PLAYERS - 1 do
        if APLayer = Players[i] then AplIdx := i + 1;

      Obj := PlayersWin.Find('lab_plname');
      Obj.AddCaption(Format('%s [%d]', [APlayer.Name, AplIdx]),
        Fonts[FN_SMBTN_L], Point(0, 0));

      Obj := PlayersWin.Find('lab_XP');
      Obj.AddCaption(Format('Zkuenosti (Voln/Celkov):    %d / %d  XP',
        [APlayer.XP, APLayer.TotXP]), Fonts[FN_OPT], Point(10, 5), false);

      Obj := PlayersWin.Find('lab_hp');
      Obj.AddCaption(fORMAT('%d', [APLayer.HP]), Fonts[FN_PLSTAT], Point(10, 0),
        false);

      Obj := PlayersWin.Find('lab_sPD');
      Obj.AddCaption(fORMAT('%d', [round(APLayer.Speed * 10)]),
        Fonts[FN_PLSTAT], Point(10, 0), false);

      PlImg.Texture := UpdatePlImg(AplIdx - 1);

      Obj := PlayersWin.Find('lab_kills');
      Obj.AddCaption(fORMAT('%d', [APLayer.Kills]), Fonts[FN_PLSTAT], Point(10, 0),
        false);

      Obj := PlayersWin.Find('lab_Deaths');
      Obj.AddCaption(fORMAT('%d', [APLayer.Deaths]),
        Fonts[FN_PLSTAT], Point(10, 0), false);



    end;
  end;

  procedure AddHP;
  begin
    if APlayer.XP < CS_HP then
    begin
      ShowMsg(', jak jsi nezkuen.M mlo XP.', 'TOHLE NEJDE', '', true);
      Exit;
    end
    else
    begin
      APlayer.XP := APLayer.XP - CS_HP;
      APLayer.HP := APlayer.HP + 1;
    end;


  end;

  procedure AddSpd;
  begin
    if APlayer.XP < CS_SPD then
    begin
      ShowMsg(', jak jsi nezkuen.M mlo XP.', 'TOHLE NEJDE', '', true);
      Exit;
    end
    else
    begin
      APlayer.XP := APLayer.XP - CS_SPD;
      APLayer.Speed := APlayer.Speed + 0.1;
    end;


  end;


  procedure NextPlImg(next: boolean = true);
  var i, idx: long;
  begin
    for i := Low(PlColors) to High(PlColors) do
      if PlColors[i] = APlayer.ImgCol then idx := i;

    if next then
    begin
      if idx < High(PlColors) then
        APlayer.ImgCol := PlColors[idx + 1]
      else
        APlayer.ImgCol := PlColors[Low(PlColors)];
    end
    else
    begin
      if idx > Low(PlColors) then
        APlayer.ImgCol := PlColors[idx - 1]
      else
        APlayer.ImgCol := PlColors[High(PlColors)];
    end;


    for i := 0 to MAX_PLAYERS - 1 do
      if (Players[i] <> APLayer) and (Players[i].ImgCol = APlayer.ImgCol) then
        NextPLImg(next);


  end;

  procedure UpdateGO;
  begin
    with UsedWins do
    begin

      OptGame.Find('tb_gs_1').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      OptGame.Find('tb_gs_2').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      OptGame.Find('tb_gs_3').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      OptGame.Find('tb_gs_4').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      OptGame.Find('tb_gs_5').Texture := TexMgr.GetTex('gui\tb_false.jpg');
      case GameOpt.GameSpeed of
        1: OptGame.Find('tb_gs_1').Texture := TexMgr.GetTex('gui\tb_true.jpg');
        2: OptGame.Find('tb_gs_2').Texture := TexMgr.GetTex('gui\tb_true.jpg');
        3: OptGame.Find('tb_gs_3').Texture := TexMgr.GetTex('gui\tb_true.jpg');
        4: OptGame.Find('tb_gs_4').Texture := TexMgr.GetTex('gui\tb_true.jpg');
        5: OptGame.Find('tb_gs_5').Texture := TexMgr.GetTex('gui\tb_true.jpg');
      end;
    end;

    Engine.SetPerf(GameOpt.GameSpeed);
  end;

  procedure UpdateKeys;
  var i: long;
  begin
    for i := 0 to MAX_PLAYERS - 1 do
      with Engine do
      begin
        if Players[i] = nil then Continue;

        Players[i].I_left := Self.Players[i].I_left;
        Players[i].I_right := Self.Players[i].I_right;
        Players[i].I_up := Self.Players[i].I_up;
        Players[i].I_down := Self.Players[i].I_down;
        Players[i].I_fire := Self.Players[i].I_fire;
        Players[i].I_fire2 := Self.Players[i].I_fire2;




      end;


  end;


var i: long;

begin
  with UsedWins do
    with MSG do
      case MSG of
        MSG_CLICKED:
          begin
            if CompStr(Obj.name, 'BTN_EXIT') then QuitGame;
            if CompStr(Obj.name, 'AniWin') then State := ST_MAINMENU;
            if CompStr(Obj.name, 'BTN_OPTIONS') then
              OptionsMain.StartFade(true);
            if CompStr(Obj.name, 'BTN_NEWGAME') then
            begin
              State := ST_NEWGAME;
            end;

            if CompStr(Obj.name, 'BTN_LOADGAME') then
              ShowMsg(GetStrings('notyet'), 'Message');

            if CompStr(Obj.name, 'BTN_OPTMAINBACK') then
            begin
              case State of
                ST_INTERGAME: InterGame.StartFade(true);
                ST_INGAME:
                  begin
                    InGMenu.StartFade(true); UpdateKeys;
                  end;

              end;

              OptionsMain.StartFade(false);
            end;
            ///////////// NEW GAME ///////////

            if CompStr(Obj.name, 'BTN_NEWBACK') then
            begin
              NGselmode.StartFade(true); NewGame.StartFade(false);
            end;
            if CompStr(Obj.name, 'BTN_NewGo') then STate := ST_INGAME;


            ///////////////////////////////////////////////

            ///////////// NG sel mode ///////////

            if CompStr(Obj.name, 'BTN_NGselmodeBack') then STate := ST_MAINMENU;
            if CompStr(Obj.name, 'BTN_camp') then
            begin
              Mode := gmCamp; NGselmode.StartFade(false);
              StoryWin.StartFade(true);
            end;
            if CompStr(Obj.name, 'BTN_user') then
            begin
              Mode := gmMaps; NGselmode.StartFade(false);
              NewGame.StartFade(true);
            end;


            ///////////////////////////////////////////////


            ///////////// INTERGAME ///////////

            if CompStr(Obj.name, 'BTN_InterGo') then STate := ST_INGAME;

            if CompStr(Obj.name, 'BTN_IPlayers') then
            begin
              UpdatePlayers;

              InterGame.StartFade(false);
              PlayersWin.StartFade(true);

            end;

            if CompStr(Obj.name, 'BTN_IDetails') then
            begin
              StoryBox.AddStrings(GetStrings(CampMgr.AMission.Details),
                Fonts[FN_story], true, true);
              Details := true;
              Intergame.StartFade(false);
              StoryWin.StartFade(true);


            end;

            if CompStr(Obj.name, 'BTN_IOpt') then
            begin
              Intergame.StartFade(false); OptionsMain.StartFade(true);
            end;
            if CompStr(Obj.name, 'BTN_IBack') then
              ShowExitMenu; //State := ST_MAINMENU;

            if CompStr(Obj.name, 'CB_pl1') then
            begin
              Players[0].Enabled := not Players[0].Enabled; UpdateInter;
            end;
            if CompStr(Obj.name, 'CB_pl2') then
            begin
              Players[1].Enabled := not Players[1].Enabled; UpdateInter;
            end;
            if CompStr(Obj.name, 'CB_pl3') then
            begin
              Players[2].Enabled := not Players[2].Enabled; UpdateInter;
            end;
            if CompStr(Obj.name, 'CB_pl4') then
            begin
              Players[3].Enabled := not Players[3].Enabled; UpdateInter;
            end;

            ///////////////////////////////////////////////


            ///////////// PLAYERS WIN ///////////

            if CompStr(Obj.name, 'BTN_PlsBack') then
            begin
              PlayersWin.StartFade(false);
              UpdateInter;
              InterGame.StartFade(true);

            end;

            if CompStr(Obj.name, 'BTN_plsnext') then
            begin
              NextPl; UpdatePlayers;
            end;

            if CompStr(Obj.name, 'BTN_plsprev') then
            begin
              Nextpl(false); UpdatePlayers;
            end;

            if CompStr(Obj.name, 'LAB_plname') then
            begin
              GetString(@APlayer.Name,'Zadej jmno', 'MOD_GETPLNAME');
            end;

            if CompStr(Obj.name, 'BTN_HP') then
            begin
              AddHP; UpdatePlayers;
            end;

            if CompStr(Obj.name, 'BTN_Spd') then
            begin
              AddSpd; UpdatePlayers;
            end;

            if CompStr(Obj.name, 'BTN_imprev') then
            begin
              NextPlImg(false); UpdatePlayers;
            end;

            if CompStr(Obj.name, 'BTN_imnext') then
            begin
              NextPlImg; UpdatePlayers;
            end;




            ///////////////////////////////////////////////



            ///////////// endGAME ///////////

            if CompStr(Obj.name, 'BTN_EGBACK') then STate := ST_MAINMeNU;


            ///////////////////////////////////////////////

            ///////////// STORYWIN ///////////

            if CompStr(Obj.name, 'BTN_StoryBack') then
            begin
              if CampMgr.AMission = nil then
                StartCampaign
              else
                StoryWin.StartFade(false);
              if Debrief then
              begin
                Debrief := false;
                InterGame.StartFade(true);
              end;
              if Endgame then EndWin.StartFade(true);
              if Details then
              begin
                InterGame.StartFade(true); Details := false;
              end;

            end;
            ///////////////////////////////////////////////



            ///////////// GFX OPTIONS ///////////
            if CompStr(Obj.name, 'BTN_OPTGFXBack') then
            begin
              OptionsMain.StartFade(true); OptGfx.StartFade(false);
            end;
            if CompStr(Obj.name, 'BTN_GFXOPT') then
            begin
              UpdateGfxOpt; OptionsMain.StartFade(false);
              OptGfx.StartFade(true);
            end;

            if CompStr(Obj.name, 'CB_FullScr') then
            begin
              ToggleFullScreen; UpdateGfxOpt;
            end;


            if CompStr(Obj.name, 'BTN_res640x16') then
              if GfxOpt.FullScreen then
              begin
                Self.SetRes(640, 480, 16, GfxOpt.FullScreen, true);
                UpdateGfxOpt;
              end
              else
                ShowMsg('Thou canst not to change resolution in window',
                  'WARNING');

            if CompStr(Obj.name, 'BTN_res640x32') then
              if GfxOpt.FullScreen then
              begin
                Self.SetRes(640, 480, 32, GfxOpt.FullScreen, true);
                UpdateGfxOpt;
              end
              else
                ShowMsg('Thou canst not to change resolution in window',
                  'WARNING');


            if CompStr(Obj.name, 'BTN_res800x16') then
              if GfxOpt.FullScreen then
              begin
                Self.SetRes(800, 600, 16, GfxOpt.FullScreen, true);
                UpdateGfxOpt;
              end
              else
                ShowMsg('Thou canst not to change resolution in window',
                  'WARNING');

            if CompStr(Obj.name, 'BTN_res800x32') then
              if GfxOpt.FullScreen then
              begin
                Self.SetRes(800, 600, 32, GfxOpt.FullScreen, true);
                UpdateGfxOpt;
              end
              else
                ShowMsg('Thou canst not to change resolution in window',
                  'WARNING');

            if CompStr(Obj.name, 'BTN_res1024x16') then
              if GfxOpt.FullScreen then
              begin
                Self.SetRes(1024, 768, 16, GfxOpt.FullScreen, true);
                UpdateGfxOpt;
              end
              else
                ShowMsg('Thou canst not to change resolution in window',
                  'WARNING');

            if CompStr(Obj.name, 'BTN_res1024x32') then
              if GfxOpt.FullScreen then
              begin
                Self.SetRes(1024, 768, 32, GfxOpt.FullScreen, true);
                UpdateGfxOpt;
              end
              else
                ShowMsg('Thou canst not to change resolution in window',
                  'WARNING');

              ////////////////////////////////////////


            ////////////////////  SFX OPTIONS
            if CompStr(Obj.name, 'BTN_OPTSFXBack') then
            begin
              OptionsMain.StartFade(true); OptSfx.StartFade(false);
            end;

            if CompStr(Obj.name, 'CB_TurnSfx') then
            begin
              GameOpt.PlaySfx := not GameOpt.PlaySfx;
              if GameOpt.PlaySfx then
                SoundMgr.Start
              else
                SoundMgr.Stop;
              UpdateSfx;
            end;

            if CompStr(Obj.name, 'TB_sVol_1') then
            begin
              GameOpt.SfxVol := 1; SoundMgr.SetVol(1);
              SoundMgr.GetSnd('gui\vamp.wav').Play; Updatesfx;
            end;
            if CompStr(Obj.name, 'TB_sVol_2') then
            begin
              GameOpt.SfxVol := 2; SoundMgr.SetVol(2);
              SoundMgr.GetSnd('gui\vamp.wav').Play; ; Updatesfx;
            end;
            if CompStr(Obj.name, 'TB_sVol_3') then
            begin
              GameOpt.SfxVol := 3; SoundMgr.SetVol(3);
              SoundMgr.GetSnd('gui\vamp.wav').Play; ; Updatesfx;
            end;
            if CompStr(Obj.name, 'TB_sVol_4') then
            begin
              GameOpt.SfxVol := 4; SoundMgr.SetVol(4);
              SoundMgr.GetSnd('gui\vamp.wav').Play; ; Updatesfx;
            end;
            if CompStr(Obj.name, 'TB_sVol_5') then
            begin
              GameOpt.SfxVol := 5; SoundMgr.SetVol(5);
              SoundMgr.GetSnd('gui\vamp.wav').Play; ; Updatesfx;
            end;


            if CompStr(Obj.name, 'BTN_SFXOPT') then
            begin
              UpdateSfx; OptionsMain.StartFade(false);
              OptSfx.StartFade(true);
            end;
            ////////////////////////////////////////////////////////

            ////////////////////  MUS OPTIONS
            if CompStr(Obj.name, 'BTN_OPTMusBack') then
            begin
              OptionsMain.StartFade(true); OptMus.StartFade(false);
            end;

            if CompStr(Obj.name, 'CB_TurnMus') then
            begin
              GameOpt.PlayMus := not GameOpt.PlayMus;
              if GameOpt.PlayMus then
                SetPList //MusMgr.IMID.PlayList.Restart(true)
              else
                MusMgr.IMID.StopAll;
              UpdateMus;
            end;

            if CompStr(Obj.name, 'CB_RandPly') then
            begin
              GameOpt.RandPly := not GameOpt.RandPly;
              SetPList;
              UpdateMus;
            end;


            if CompStr(Obj.name, 'TB_Vol_1') then
            begin
              GameOpt.MusVol := 1; MusMgr.SetVol(1); UpdateMus;
            end;
            if CompStr(Obj.name, 'TB_Vol_2') then
            begin
              GameOpt.MusVol := 2; MusMgr.SetVol(2); UpdateMus;
            end;
            if CompStr(Obj.name, 'TB_Vol_3') then
            begin
              GameOpt.MusVol := 3; MusMgr.SetVol(3); UpdateMus;
            end;
            if CompStr(Obj.name, 'TB_Vol_4') then
            begin
              GameOpt.MusVol := 4; MusMgr.SetVol(4); UpdateMus;
            end;
            if CompStr(Obj.name, 'TB_Vol_5') then
            begin
              GameOpt.MusVol := 5; MusMgr.SetVol(5); UpdateMus;
            end;


            if CompStr(Obj.name, 'BTN_MusOPT') then
            begin
              UpdateMus; OptionsMain.StartFade(false);
              OptMus.StartFade(true);
            end;
            ////////////////////////////////////////////////////////

            ////////////////////  GAME OPTIONS
            if CompStr(Obj.name, 'BTN_OPTGameBack') then
            begin
              OptionsMain.StartFade(true); Optgame.StartFade(false);
            end;

            if CompStr(Obj.name, 'TB_gs_1') then
            begin
              GameOpt.GameSpeed := 1; UpdateGo;
            end;

            if CompStr(Obj.name, 'TB_gs_2') then
            begin
              GameOpt.GameSpeed := 2; UpdateGo;
            end;

            if CompStr(Obj.name, 'TB_gs_3') then
            begin
              GameOpt.GameSpeed := 3; UpdateGo;
            end;

            if CompStr(Obj.name, 'TB_gs_4') then
            begin
              GameOpt.GameSpeed := 4; UpdateGo;
            end;

            if CompStr(Obj.name, 'TB_gs_5') then
            begin
              GameOpt.GameSpeed := 5; UpdateGo;
            end;


            if CompStr(Obj.name, 'BTN_GameOPT') then
            begin
              UpdateGO; OptionsMain.StartFade(false); OptGame.StartFade(true);
            end;
            ////////////////////////////////////////////////////////

            ////////////////////  Input OPTIONS
            if CompStr(Obj.name, 'BTN_OPTInBack') then
            begin
              OptionsMain.StartFade(true); OptIn.StartFade(false);
            end;
            if CompStr(Obj.name, 'BTN_InOpt') then
            begin
              UpdateInput; OptionsMain.StartFade(false);
              OptIn.StartFade(true);
            end;

            if CompStr(Obj.name, 'BTN_plnext') then
            begin
              NextPl; UpdateInput;
            end;

            if CompStr(Obj.name, 'BTN_plprev') then
            begin
              Nextpl(false); UpdateInput;
            end;

            if CompStr(Obj.name, 'BTN_iup') then
            begin
              GetKey(@APlayer.I_up);
            end;

            if CompStr(Obj.name, 'BTN_idown') then
            begin
              GetKey(@APlayer.I_down);
            end;

            if CompStr(Obj.name, 'BTN_ileft') then
            begin
              GetKey(@APlayer.I_left);
            end;

            if CompStr(Obj.name, 'BTN_iright') then
            begin
              GetKey(@APlayer.I_right);
            end;

            if CompStr(Obj.name, 'BTN_ifire1') then
            begin
              GetKey(@APlayer.I_fire);
            end;

            if CompStr(Obj.name, 'BTN_ifire2') then
            begin
              GetKey(@APlayer.I_fire2);
            end;

            ////////////////////////////////////////////////////////

            ////////////////////  CREDITS
            if CompStr(Obj.name, 'BTN_CreditsBack') then
            begin
            //MainMenu.StartFade(true);
            //Credits.StartFade(false);
              SoundMgr.RemoveSnd('summoning.mp3');
            //TBStream(SoundMgr.GetSnd('summoning.mp3')).Stop;
              if GameOpt.PlayMus then MusMgr.IMID.PlayList.Play;
              State := ST_MAINMENU;
            end;

            if CompStr(Obj.name, 'BTN_CREDITS') then
            begin
              State := ST_CREDITS;
            end;
            ////////////////////////////////////////////////////////

            ////////////////////  INGMENU
            if CompStr(Obj.name, 'BTN_imBack') then
            begin
              IngMenu.StartFade(false);
              if state <> st_ingame then
              begin
                UsedWins.IngMenu.Find('BTN_EndMap').Hide;
                UsedWins.IngMenu.Find('BTN_igopt').Hide;
              end;
              if state = st_ingame then Engine.Resume;
            end;

            if CompStr(Obj.name, 'BTN_EndMap') then
            begin
              State := ST_INTERGAME;
            end;


            if CompStr(Obj.name, 'BTN_Win') then
            begin
              QuitGame;
            end;

            if CompStr(Obj.name, 'BTN_igOpt') then
            begin
              Ingmenu.StartFade(false);
              OptionsMain.StartFade(true);
              OptionsMain.ToFront;
            end;

            if CompStr(Obj.name, 'BTN_MMENU') then
            begin
              State := ST_MAINMENU;
            end;
            ////////////////////////////////////////////////////////


          end;
        MSG_MODAL:
          begin
            if CompStr(Data, 'MOD_NEWGAME') then
            begin
              State := ST_INGAME;
            end;

            if CompStr(Data, 'MOD_ENGINESTOP') then
            begin
              Engine.Resume;
            end;

            if CompStr(Data, 'MOD_DEMOEND') then
            begin
              Engine.Clear;
              State := ST_MAINMENU;
            end;

            if CompStr(Data, 'MOD_MAPEND') then NextMap;

            if CompStr(Data, 'MOD_GETKEY') then
            begin
              Editing := false;
              AKey^ := KeyVal;
              AKey := nil;

              UpdateInput;
            end;

            if CompStr(Data, 'MOD_GETPLNAME') then
            begin
              Editing := false;
              AStr^ := StrVal;
              AStr := nil;

              UpdatePlayers;
            end;

           if CompStr(Data, 'MOD_CONSOLE') then
            begin
              Editing := false;
              AStr^ := StrVal;
              AStr := nil;
              Engine.Resume;
              DoCommand(ConCmd);

            end;

          end;
        MSG_FADEDIN:
          begin
           //if CompStr(Obj.name, 'AniWin') then SoundMgr.GetSnd('gui\vamp.wav').play;
          //  if CompStr(obj.name, 'Intergame') then UpdateNew;



          end;




      end;
end;

procedure TDrakeApp.GetKey(key: pword; data: string = 'MOD_GETKEY');
  var Obj: Tguiobj;
  begin
    with UsedWins do
    begin
      AKey := Key;
      Editing := true;
      KeyVal := AKey^;

      Obj := InputWin.Find('ilabel');
      Obj.AddCaption('Stiskni klvesu', Fonts[FN_MSGLAB], Point(0, 0));

      Obj := InputWin.Find('lab_iedit');
      Obj.AddCaption(VirtualKeyCodeToKeyName(KeyVal), Fonts[FN_edit], Point(0,
        0));

      WinMgr.ShowModal(InputWin, InputWin.Find('BTN_IOK'), data);
      InputWin.ToFront;

    end;
  end;

  procedure TDrakeApp.GetString(str: pstring; capt:string='Zadej jmno'; data: string = 'MOD_GETSTR');
  var Obj: Tguiobj;
    Msg: TMsg;
  begin
    with UsedWins do
    begin
      AStr := Str;
      Editing := true;
      StrVal := AStr^;
      StrPos := Length(StrVal) + 1;

      Obj := InputWin.Find('ilabel');
      Obj.AddCaption(capt, Fonts[FN_MSGLAB], Point(0, 0));

      Obj := InputWin.Find('lab_iedit');
      Obj.AddCaption(StrVal, Fonts[FN_edit], Point(0,
        0));

      ProcessEdit(Msg);

      WinMgr.ShowModal(InputWin, InputWin.Find('BTN_IOK'), data);
      InputWin.ToFront;


    end;
  end;



procedure TDrakeApp.ChangeStoryBox(List: string);
begin
  UsedWins.StoryBox.AddStrings(GetStrings(List), Fonts[FN_story], true, true);

end;

procedure TDrakeApp.UpdateInter();
begin
  with UsedWins do
  begin
    InterGame.Find('text_inter').AddStrings(GetStrings(CampMgr.AMission.BeforeInf), Fonts[FN_txtwin], true, true);

    if Players[0].Enabled then
      InterGame.Find('CB_pl1').Texture := TexMgr.GetTex('gui\cb_true.jpg')
    else
      InterGame.Find('CB_pl1').Texture := TexMgr.GetTex('gui\cb_false.jpg');

    if Players[1].Enabled then
      InterGame.Find('CB_pl2').Texture := TexMgr.GetTex('gui\cb_true.jpg')
    else
      InterGame.Find('CB_pl2').Texture := TexMgr.GetTex('gui\cb_false.jpg');

    if Players[2].Enabled then
      InterGame.Find('CB_pl3').Texture := TexMgr.GetTex('gui\cb_true.jpg')
    else
      InterGame.Find('CB_pl3').Texture := TexMgr.GetTex('gui\cb_false.jpg');

    if Players[3].Enabled then
      InterGame.Find('CB_pl4').Texture := TexMgr.GetTex('gui\cb_true.jpg')
    else
      InterGame.Find('CB_pl4').Texture := TexMgr.GetTex('gui\cb_false.jpg');

    Intergame.Find('Lab_pl1').AddCaption(Players[0].name, Fonts[FN_MEDBTN],
      Point(0, 0));
    Intergame.Find('Lab_pl2').AddCaption(Players[1].name, Fonts[FN_MEDBTN],
      Point(0, 0));
    Intergame.Find('Lab_pl3').AddCaption(Players[2].name, Fonts[FN_MEDBTN],
      Point(0, 0));
    Intergame.Find('Lab_pl4').AddCaption(Players[3].name, Fonts[FN_MEDBTN],
      Point(0, 0));


  end;

end;


procedure TDrakeApp.ShowDebrief();
var List: TStringList;
  i: long;
begin
  with UsedWins do
  begin
    List := TStrinGList.Create;
    List.Assign(GetStrings(TMInfo(CampMgr.Infos[campMgr.Infos.IndexOf(CampMgr.AMission) - 1]).AfterInf));
    List.Add('');
    List.Add('');
    List.Add(Format('Bonus za misi: %d  XP',[TMInfo(CampMgr.Infos[campMgr.Infos.IndexOf(CampMgr.AMission) - 1]).XPbonus]));
    List.Add('');

    for i:=0 to MAX_PLAYERS-1 do
     if Players[i].Enabled then
      List.Add(Format('[%s] zskal %d  XP',[Players[i].Name, Players[i].DXP]));

    StoryBox.AddStrings(List, Fonts[FN_story], true, true);
    StoryWin.ToFront;
    StoryWin.StartFade(true);
    List.Free;
  end;

end;


procedure TDrakeApp.CreateSnap;
var idx: long;
  Bmp: TBitmap;
begin
  Bmp := TBitmap.Create;
  Bmp.Width := Window.ClientWidth;
  Bmp.Height := Window.ClientHeight;

  Bmp.Canvas.CopyRect(Rect(0, 0, Bmp.Width, Bmp.Height), Window.Canvas, Rect(0,
    0, Bmp.Width, Bmp.Height));
  Bmp.PixelFormat := pf24bit;


  for idx := 0 to 500 do
    if FileExists(Format(rootdir + 'screenshot%d.bmp', [idx])) then
      Continue
    else
    begin
      Bmp.SaveToFile(Format(rootdir + 'screenshot%d.bmp', [idx])); break;
    end;

  Bmp.free;


end;

procedure TDrakeApp.ProcessEdit(Msg: TMsg);
var i: long;
  p: pchar;
  Key: word;
  K: TKeyBoardState;
  st: string;
begin
  Key := Msg.wParam;
  p := stralloc(2);
  GetKeyBoardState(K);
  ToAscii(Key, MapVirtualKey(Key, 0), K, p, 0);

  case Key of
    VK_LEFT:
      if strpos > 1 then strpos := strpos - 1;
    VK_RIGHT:
      if strpos <= Length(strval) then strpos := strpos + 1;
    VK_DELETE: Delete(strval, strpos, 1);
    VK_BACK:
      begin
        Delete(strval, strpos - 1, 1);
        if strpos > 1 then Inc(strpos, -1);
      end;
    VK_HOME: strpos := 1;
    VK_END: strpos := Length(strval) + 1;

    32, $30..255:
      begin
        Insert(p, strval, strPos);
        Inc(strPos, 1);
      end;
  end;

  strdispose(p);

  st := strval;
  Insert('|', st, strpos);

  UsedWins.IEdit.AddCaption(st, Fonts[FN_edit],
    Point(0, 0));


end;



type

  TCtrlRec = array[0..10] of word;

  TCtrlArr = array[0..MAX_PLAYERS - 1] of TCtrlREc;

procedure TDrakeApp.LoadControls;
var Ctrls: TCtrlArr;
  F: file of TCtrlArr;
  i: long;
begin
  AssignFile(F, RootDir + 'Data\Config\controls.cfg');
  System.Reset(F);
  Read(F, Ctrls);
  CloseFile(F);

  for i := 0 to MAX_PLAYERS - 1 do
  begin
    Players[i].I_left := Ctrls[i][0];
    Players[i].I_right := Ctrls[i][1];
    Players[i].I_up := Ctrls[i][2];
    Players[i].I_down := Ctrls[i][3];
    Players[i].I_fire := Ctrls[i][4];
    Players[i].I_fire2 := Ctrls[i][5];

  end;


end;

procedure TDrakeApp.SaveControls;
var Ctrls: TCtrlArr;
  F: file of TCtrlArr;
  i: long;
begin
  for i := 0 to MAX_PLAYERS - 1 do
  begin
    Ctrls[i][0] := Players[i].I_left;
    Ctrls[i][1] := Players[i].I_right;
    Ctrls[i][2] := Players[i].I_up;
    Ctrls[i][3] := Players[i].I_down;
    Ctrls[i][4] := Players[i].I_fire;
    Ctrls[i][5] := Players[i].I_fire2;


  end;

  AssignFile(F, RootDir + 'Data\Config\controls.cfg');
  Rewrite(F);
  Write(F, Ctrls);
  CloseFile(F);


end;


procedure TDrakeApp.ShowExitMenu();
begin
  if UsedWins.IngMenu.Visible then Exit;

  UsedWins.IngMenu.StartFade(true);
  UsedWins.IngMenu.Find('BTN_EndMap').Hide;
  UsedWins.IngMenu.Find('BTN_igopt').Hide;


  case State of
    ST_INGAME:
      begin
        Engine.Stop;
        UsedWins.IngMenu.Find('BTN_EndMap').Show;
        UsedWins.IngMenu.Find('BTN_igopt').Show;

      end;
  else
    begin

    end;

  end;



end;


procedure TDrakeApp.ShowConsole;
begin
  Engine.Stop;
  GetString(@ConCmd,'Type command','MOD_CONSOLE');
end;


end.

