{
  Drake Rider

  (C) 2002 Vampyre SoftWorks
  Created by :  Marek Mauder  
}	



unit EngEquip;

interface

uses Windows, Classes, SysUtils, WinFunc,
gameTypes,ContNRS,DXObj,MainGame;

type



  TEquip = class
  public
    Name: string;
    Value:long;

    constructor Create(AName: string); virtual;
    destructor Destroy; override;

    procedure Save(S:TStream);virtual;
    procedure Load(S:TStream);virtual;
        
  end;

  TArmor = class(TEquip)
  public
    AC: long;


    constructor Create(AName: string); override;
    destructor Destroy; override;

    procedure Save(S:TStream);override;
    procedure Load(S:TStream);override;
    
    
  end;

  TWeapon = class(TEquip)
  public
    Damage: long;
    Cadence:single;
    Tex:string;
    pWidth:long;
    pHeight:long;
    pSpeed:single;
    Ranged:boolean;
    Blend:TDXBlend;
        
    constructor Create(AName: string);override;
    destructor Destroy; override;

    procedure Save(S:TStream);override;
    procedure Load(S:TStream);override;
    
  end;


  TWeaponMgr=class
              Objects:TObjectList;
  

              constructor Create;
              destructor Destroy;override;

              procedure Load;
              procedure Save;
              function Get(Name:string):TWeapon;
  
             end;

  TArmorMgr=class
              Objects:TObjectList;
            
              constructor Create;
              destructor Destroy;override;

              procedure Load;
              procedure Save;
              function Get(Name:string):TArmor;
  
             end;
         
  

var WeaponMgr:TWeaponMgr;
    ArmorMgr:TArmorMgr;


type 

   THdr=record
         ID:TChar4;
         S1:char;
         Info:TChar20;
         S2:char;
        end;
    
implementation

/////////////////////// BASE CLASS  TEQUIP

constructor TEquip.Create(AName: string);
begin
  inherited Create;
  Name := AName;

end;

destructor TEquip.Destroy;
begin

  inherited;
end;

procedure TEquip.Save(S:TStream);
begin
WriteStr(S,Name);
S.WriteBuffer(Value,SizeOf(Value));
end;

procedure TEquip.Load(S:TStream);
begin
Name:=ReadStr(S);
S.ReadBuffer(Value,SizeOf(Value));
end;
    

///////////////////////  TARMOR

constructor TArmor.Create(AName: string);
begin
  inherited Create(AName);
  AC:=0;
  Name:='Kokazbroj';

end;

destructor Tarmor.Destroy;
begin

  inherited;
end;

procedure TArmor.Save(S:TStream);
begin
inherited;
S.WriteBuffer(AC,SizeOf(AC));
end;

procedure TArmor.Load(S:TStream);
begin
inherited;
S.ReadBuffer(AC,SizeOf(AC));
end;


///////////////////////  TWEAPON

constructor TWeapon.Create(AName: string);
begin
  inherited Create(AName);
  Damage:=50;
  Name:='KokaWepon';
  pWidth:=32;
  pHeight:=16;
  pSpeed:=4;
  Cadence:=1;
  Ranged:=true;
  Tex:='shoots\red.png';

end;

destructor TWeapon.Destroy;
begin

  inherited;
end;


procedure TWeapon.Save(S:TStream);
begin
inherited;
WriteStr(S,Tex);
S.WriteBuffer(Damage,SizeOf(Damage));
S.WriteBuffer(Cadence,SizeOf(cadence));
S.WriteBuffer(pWidth,SizeOf(pWidth));
S.WriteBuffer(pHeight,SizeOf(pheight));
S.WriteBuffer(pSpeed,SizeOf(pSpeed));
S.WriteBuffer(Blend,SizeOf(Blend));


end;

procedure TWeapon.Load(S:TStream);
begin
inherited;
Tex:=ReadStr(S);
S.ReadBuffer(Damage,SizeOf(Damage));
S.ReadBuffer(Cadence,SizeOf(cadence));
S.ReadBuffer(pWidth,SizeOf(pWidth));
S.ReadBuffer(pHeight,SizeOf(pheight));
S.ReadBuffer(pSpeed,SizeOf(pSpeed));
S.ReadBuffer(Blend,SizeOf(Blend));

end;

/////////////////////  TWEAPONMGR

constructor TWeaponMgr.Create;
begin
 inherited Create;
 Objects:=TObjectList.Create;

 end;

destructor TWeaponMgr.Destroy;
begin

 Objects.Free;
 inherited;
end;

procedure TWeaponMgr.Load;
var MS:TMS;
    cnt,i:long;
    W:TWeapon;
    Hd:THdr;
begin
 MS:=TMS.Create;
 MS.LoadFromFile(Exedir+FL_WEAPONS);

 Objects.Clear;

 MS.ReadBuffer(Hd,SizeOf(HD));
 MS.ReadBuffer(cnt,SizeOf(cnt));
 for i:=0 to cnt-1 do
  begin
   W:=TWeapon.Create('');
   W.Load(MS);
   Objects.Add(W);
  end;
 
 
 MS.Free;
end;

procedure TWeaponMgr.Save;
var MS:TMS;
    i:long;
    Hd:THdr;
begin
 MS:=TMS.Create;

 Hd.ID:='DRWC';
 Hd.S1:=#1;
 Hd.Info:='DR WEAPONS CONFIG';
 Hd.S2:=#1;

 MS.WriteBuffer(Hd,SizeOf(Hd));
 MS.WriteBuffer(Objects.Count,sizeof(Integer));

 for i:=0 to Objects.Count-1 do
  TWeapon(OBjects[i]).Save(MS);
 
 
 MS.SaveToFile(Exedir+FL_WEAPONS);
 MS.Free;

end;

function TWeaponMgr.Get(Name:string):TWeapon;
var i:long;
begin
Result:=nil;
for i:=0 to OBjects.Count-1 do
 if CompStr(Name,TWeapon(Objects[i]).Name) Then Result:=TWeapon(Objects[i]);

  
end;


//////////////// TARMORMGR
constructor TArmorMgr.Create;
begin
 inherited Create;
 Objects:=TObjectList.Create;

 end;

destructor TArmorMgr.Destroy;
begin

 Objects.Free;
 inherited;
end;

procedure TArmorMgr.Load;
var MS:TMS;
 cnt,i:long;
    Hd:THdr;
    A:tarmor;
begin
 MS:=TMS.Create;
 MS.LoadFromFile(Exedir+FL_ARMORS);

 Objects.Clear;

 MS.ReadBuffer(Hd,SizeOf(HD));
 MS.ReadBuffer(cnt,SizeOf(cnt));
 for i:=0 to cnt-1 do
  begin
   A:=TArmor.Create('');
   A.Load(MS);
   Objects.Add(A);
  end;
 
 
 MS.Free;
end;

procedure TArmorMgr.Save;
var MS:TMS;
    i:long;
    Hd:THdr;
begin
 MS:=TMS.Create;

 Hd.ID:='DRAC';
 Hd.S1:=#1;
 Hd.Info:='DR ARMORS CONFIG';
 Hd.S2:=#1;

 MS.WriteBuffer(Hd,SizeOf(Hd));
 MS.WriteBuffer(Objects.Count,sizeof(Integer));

 for i:=0 to Objects.Count-1 do
  TArmor(OBjects[i]).Save(MS);
 
 
 MS.SaveToFile(FL_ARMORS);
 MS.Free;

end;


function TArmorMgr.Get(Name:string):TArmor;
var i:long;
begin
Result:=nil;
for i:=0 to OBjects.Count-1 do
 if CompStr(Name,TArmor(Objects[i]).Name) Then Result:=TArmor(Objects[i]);

  
end;


end.

 