{
  Drake Rider

  (C) 2002 Vampyre SoftWorks
  Created by :  Marek Mauder  
}	


unit EngineObj;

interface

uses Windows, Classes, Sysutils, DirectXGraphics, KeyBoard, Messages,
  D3DX8, DXObj, gameTypes, WinFunc, MainGame, DXStuff, Sound,
   EngEquip,Graphics;

var

  ///// speeds
  SP_PLAYER: single = 4.0;
  SP_World: single = -2;
  SP_MainBack: single = 0.0005;
  SP_NearBack: single = 0.0015;


const
  // Z values
  Z_DEF = -100;
  Z_BACK = -10;
  Z_NEARBACK = -9;
  Z_NEAR2BACK = -8;
  Z_DECOR = 0;
  Z_ENTITY = 1;
  Z_FRIENDLY=2;
  Z_BOSS=3;
  Z_PLAYER = 4;
  Z_PROJECTILE = 5;

  /// color
  CL_DEF = 0;
  CL_OBJ = $FFFFFFFF;

type

  TGunner = (gn_Enemy, gn_Player);

  TBlocking = (bk_Block, bk_None, Bk_Injury);

  TBaseInfo=class;

  TBaseObj = class(TDXPanelEx)
  public
    Z: long;
    Engine: TObject;
    WorldX,
      WorldY: long;
    Speed: single;


    Deaded: boolean;
    Modified: boolean;
    Group: string;

    constructor Create(ADev: IDevice;
      ABounds: TRect; Tex: TDXTexture = nil;
      AColor: TD3DColor = CL_DEF; AZ: long = Z_DEF; AInit: boolean = true

      ); reintroduce; virtual;

    procedure CheckInput; virtual;
    procedure DoMove; virtual;

    procedure Move(x, y: single); override;
    function OnScreen: boolean; virtual;
    function GetRect: TRect; virtual;


    procedure Render; override;

    procedure SetDefaults; virtual;

    procedure PlaySnd(AName: string);

    procedure SaveToStream(S: TStream); virtual;
    procedure LoadFromStream(S: TStream); virtual;
    procedure SaveUnMod(S: TStream); virtual;
    procedure SaveMod(S: TStream); virtual;
    procedure LoadMod(S: TStream); virtual;
    procedure LoadUnMod(S: TStream); virtual;

    function Clone(recreate: boolean = true): TBaseObj; virtual;
    procedure LoadFromInfo(I:TBaseInfo);virtual;

  end;

  TBaseInfo = class(TPersistent)
  public
    Group:string;
             // mods
    Name: string;
    X,
      Y: long;

          //statics
    Width,
      Height: long;
    Z: long;
    Color:dword;
    TexName: string;
    Blend: TDXBlend;
    Speed: single;
    FWidth,
      FHeight: long;

    constructor Create;virtual;
    procedure SetDefaults;virtual;

    procedure Load(S: TStream); virtual;
    procedure Save(S: TStream); virtual;

    function Clone:TBaseInfo;

  end;


  TBackGround = class(TBaseObj)
  public
    minu,
      maxu: single;
    speed_u: single;
    tw, th: long;

    constructor Create(ADev: IDevice;
      ABounds: TRect; Tex: TDXTexture = nil;
      AColor: TD3DColor = Cl_DEF; AZ: long = Z_DEF; AInit: boolean = true

      ); override;




    procedure DoMove; override;
    procedure SetDefaults; override;


  end;

  TBackGroundInfo = class(TBaseInfo)
  public


    procedure Load(S: TStream); override;
    procedure Save(S: TStream); override;

    procedure SetDefaults;override;

  end;


  TColObj = class(TBaseObj)
  public
    cx,
      cy: single;
    Block: TBlocking;
    Animed:boolean;

    constructor Create(ADev: IDevice;
      ABounds: TRect; Tex: TDXTexture = nil;
      AColor: TD3DColor = CL_DEF; AZ: long = Z_DEF; AInit: boolean = true

      ); override;


    procedure DoMove; override;
    procedure Move(x, y: single); override;
    procedure TestCol; virtual;
    procedure DoCol(Obj: TColObj); virtual;
    procedure SetDefaults; override;

    procedure LoadFromInfo(I:TBaseInfo);override;

  end;

  TColObjInfo = class(TBaseInfo)
  public
    Block: TBlocking;
    Animed:boolean;

    procedure Load(S: TStream); override;
    procedure Save(S: TStream); override;

    procedure SetDefaults;override;

  end;


  TDecor = class(TColObj)
  public


    procedure DoMove; override;
    procedure SetDefaults; override;
    procedure TestCol; override;

    procedure DoCol(Obj: TColObj); override;


  end;

  TDecorInfo = class(TColObjInfo)
  public

    procedure Load(S: TStream); override;
    procedure Save(S: TStream); override;

    procedure SetDefaults;override;

  end;

  TEntity = class(TColObj)
  protected
    procedure SetHP(Value: long); virtual; abstract;

  public
    Attacker: TEntity;

    Armor: TArmor;
    Ranged: TWeapon;
    Melee: TWeapon;

    FHP: long;
    XP: long;
    MaxHP:long;

    FOldOnScr:boolean;

    sndFire: string;
    sndDie: string;
    sndHit: string;
    sndAmb: string;

    constructor Create(ADev: IDevice;
      ABounds: TRect; Tex: TDXTexture = nil;
      AColor: TD3DColor = CL_DEF; AZ: long = Z_DEF; AInit: boolean = true

      ); override;

    procedure DoFire; virtual;
    procedure TestCol; override;
    procedure DoCol(Obj: TColObj); override;
    procedure SetDefaults; override;
    procedure Kill; virtual;

    procedure LoadFromInfo(I:TBaseInfo);override;

    function OnScreen: boolean; override;

    property HP: long read FHp write SetHP;


  end;

  TEntityInfo = class(TColObjInfo)
  public
    WRanged,
    WMelee: string;
    Armor: string;
    HP,
      XP: long;

    sndFire: string;
    sndDie: string;
    sndHit: string;
    sndAmb: string;

    procedure Load(S: TStream); override;
    procedure Save(S: TStream); override;



    procedure SetDefaults;override;

  end;


  TEnemy = class(TEntity)
  protected
    procedure SetHP(Value: long); override;

  public

    constructor Create(ADev: IDevice;
      ABounds: TRect; Tex: TDXTexture = nil;
      AColor: TD3DColor = CL_DEF; AZ: long = Z_DEF; AInit: boolean = true
      ); override;

    procedure DoMove; override;
    procedure DoFire; override;
    procedure Kill; override;

    procedure DoCol(Obj: TColObj); override;
    procedure SetDefaults; override;

    
  end;

  TEnemyInfo = class(TEntityInfo)
  public

   procedure Load(S: TStream); override;
   procedure Save(S: TStream); override;

   procedure SetDefaults;override;

  end;


  TBoss = class(TEnemy)
  private
    ax,
    ay:single;
    FAscend:boolean;
  public
    procedure Kill; override;
    procedure DoMove; override;
    procedure SetDefaults; override;
  end;

  TBossInfo = class(TEnemyInfo)
  public

   procedure Load(S: TStream); override;
   procedure Save(S: TStream); override;

   procedure SetDefaults;override;

  end;


  TPlayer = class(TEntity)
  protected
    procedure SetHP(Value: long); override;

  public

    I_left: word;
    I_right: word;
    I_up: word;
    I_down: word;
    I_fire: word;
    I_fire2:word;

    Kills:long;
    Deaths:long;

    RangedB:TWeapon;
    Enabled:boolean;

    ImgCol:dword;

    constructor Create(ADev: IDevice;
      ABounds: TRect; Tex: TDXTexture = nil;
      AColor: TD3DColor = CL_DEF; AZ: long = Z_DEF; AInit: boolean = true

      ); override;

    procedure CheckInput; override;
    procedure Move(x, y: single); override;
    procedure DoFire; override;
    procedure DoMove; override;
    procedure DoCol(Obj: TColObj); override;
    procedure SetDefaults; override;
    procedure Kill; override;

    procedure LoadFromInfo(I:TBaseInfo);override;

  end;

  TPlayerInfo = class(TEntityInfo)
  public
    I_left: word;
    I_right: word;
    I_up: word;
    I_down: word;
    I_fire: word;
    I_fire2: word;
    WRangedB:string;

    TotXP:long;
    DXP:long;
    Kills:long;
    Deaths:long;

    Image:TBitmap;
    ImgCol:dword;

    Enabled:boolean;
    procedure Load(S: TStream); override;
    procedure Save(S: TStream); override;

    procedure SetDefaults;override;
    procedure SetPos(x,y:long);

  end;


  TProjectile = class(TColObj)
  public
    Owner: TEntity;

    Gunner: TGunner;
    MaxRange: long;
    ActRange: single;
    Damage: long;


    constructor Create(ADev: IDevice;
      ABounds: TRect; Tex: TDXTexture = nil;
      AColor: TD3DColor = CL_DEF; AZ: long = Z_DEF; AInit: boolean = true

      ); override;

    procedure DoMove; override;
    procedure SetDefaults; override;

  end;

  TBaseObjList = class(TList)
  private
    FOwnsObjects: Boolean;
  protected
    procedure Notify(Ptr: Pointer; Action: TListNotification); override;
    function GetItem(Index: Integer): TBaseObj;
    procedure SetItem(Index: Integer; ABaseObj: TBaseObj);
  public
    constructor Create; overload;
    constructor Create(AOwnsObjects: Boolean); overload;

    function Add(ABaseObj: TBaseObj): Integer;
    function Remove(ABaseObj: TBaseObj): Integer;
    function IndexOf(ABaseObj: TBaseObj): Integer;
    procedure Insert(Index: Integer; ABaseObj: TBaseObj);
    property OwnsObjects: Boolean read FOwnsObjects write FOwnsObjects;
    property Items[Index: Integer]: TBaseObj read GetItem write SetItem; default;
  end;

  TBaseInfoList = class(TList)
  private
    FOwnsObjects: Boolean;
  protected
    procedure Notify(Ptr: Pointer; Action: TListNotification); override;
    function GetItem(Index: Integer): TBaseInfo;
    procedure SetItem(Index: Integer; ABaseInfo: TBaseInfo);
  public
    constructor Create; overload;
    constructor Create(AOwnsObjects: Boolean); overload;

    function Add(ABaseInfo: TBaseInfo): Integer;
    function Remove(ABaseInfo: TBaseInfo): Integer;
    function IndexOf(ABaseInfo: TBaseInfo): Integer;
    procedure Insert(Index: Integer; ABaseInfo: TBaseInfo);
    property OwnsObjects: Boolean read FOwnsObjects write FOwnsObjects;
    property Items[Index: Integer]: TBaseInfo read GetItem write SetItem; default;
  end;


  TEngObjClass = class of TBaseObj;
  TEngObjInfo = class of TBaseInfo;

implementation

uses EngineMain;

var
  Eng: TEngine;
  Stopped:boolean=false;
//////////////////  TBaseObjLIST



function TBaseObjList.Add(ABaseObj: TBaseObj): Integer;
begin
  Result := inherited Add(ABaseObj);
end;



constructor TBaseObjList.Create;
begin
  inherited Create;
  FOwnsObjects := True;
end;

constructor TBaseObjList.Create(AOwnsObjects: Boolean);
begin
  inherited Create;
  FOwnsObjects := AOwnsObjects;
end;


function TBaseObjList.GetItem(Index: Integer): TBaseObj;
begin
  Result := inherited Items[Index];
end;

function TBaseObjList.IndexOf(ABaseObj: TBaseObj): Integer;
begin
  Result := inherited IndexOf(ABaseObj);
end;

procedure TBaseObjList.Insert(Index: Integer; ABaseObj: TBaseObj);
begin
  inherited Insert(Index, ABaseObj);
end;

procedure TBaseObjList.Notify(Ptr: Pointer; Action: TListNotification);
begin
  if OwnsObjects then
    if Action = lnDeleted then
      TBaseObj(Ptr).Free;
  inherited Notify(Ptr, Action);
end;

function TBaseObjList.Remove(ABaseObj: TBaseObj): Integer;
begin
  Result := inherited Remove(ABaseObj);
end;

procedure TBaseObjList.SetItem(Index: Integer; ABaseObj: TBaseObj);
begin
  inherited Items[Index] := ABaseObj;
end;

//////////////////  TBaseInfoLIST



function TBaseInfoList.Add(ABaseInfo: TBaseInfo): Integer;
begin
  Result := inherited Add(ABaseInfo);
end;



constructor TBaseInfoList.Create;
begin
  inherited Create;
  FOwnsObjects := True;
end;

constructor TBaseInfoList.Create(AOwnsObjects: Boolean);
begin
  inherited Create;
  FOwnsObjects := AOwnsObjects;
end;


function TBaseInfoList.GetItem(Index: Integer): TBaseInfo;
begin
  Result := inherited Items[Index];
end;

function TBaseInfoList.IndexOf(ABaseInfo: TBaseInfo): Integer;
begin
  Result := inherited IndexOf(ABaseInfo);
end;

procedure TBaseInfoList.Insert(Index: Integer; ABaseInfo: TBaseInfo);
begin
  inherited Insert(Index, ABaseInfo);
end;

procedure TBaseInfoList.Notify(Ptr: Pointer; Action: TListNotification);
begin
  if OwnsObjects then
    if Action = lnDeleted then
      TBaseInfo(Ptr).Free;
  inherited Notify(Ptr, Action);
end;

function TBaseInfoList.Remove(ABaseInfo: TBaseInfo): Integer;
begin
  Result := inherited Remove(ABaseInfo);
end;

procedure TBaseInfoList.SetItem(Index: Integer; ABaseInfo: TBaseInfo);
begin
  inherited Items[Index] := ABaseInfo;
end;





//////////////////////  TBASE OBJ

constructor TBaseObj.Create(ADev: IDevice;
  ABounds: TRect; Tex: TDXTexture;
  AColor: TD3DColor; AZ: long; AInit: boolean);
begin
  if AColor = CL_DEF then AColor := CL_OBJ;
  inherited Create(ADev, ABounds, AColor, Tex, '', AInit);
  Z := AZ;
  WorldX := GetPos.X;
  WorldY := GetPos.Y;
  Tag3 := GetTickCount;
  Modified := false;
  SetDefaults;

end;

procedure TBaseObj.CheckInput;
begin
end;

procedure TBaseObj.DoMove;
begin
  if Eng = nil then Eng := TEngine(Engine);
  if OnScreen then DoTimer;


end;

procedure TBaseObj.Move(x, y: single);
var
  iy: single;
  Pos: TVector2;
begin
  Pos := GetRealPos;
  iy := y;

  if ((Pos.Y + y) < Eng.Sky - 5) or ((Pos.Y + y) > (Eng.Dim.Y - Eng.Ground) - Bounds.Bottom) then iy := 0;

  inherited Move(x, iy);
end;

function TBaseObj.OnScreen: boolean;
var P:TPoint;
begin
  if Eng <> nil then
    begin

    Result := DXStuff.OverlapRect(GetRect, Rect(0, 0, Eng.Dim.X, Eng.Dim.Y))

     end
  else
    Result := true;

end;


procedure TBaseObj.Render;
begin
  if not OnScreen then Exit;

  inherited;
end;


function TBaseObj.GetRect: TRect;
var P:TPoint;
begin
  P:=GetPos;
  Result := Rect(P.X, P.Y, P.X + Bounds.Right, P.Y + Bounds.Bottom);

end;

procedure TBaseObj.SetDefaults;
begin
  Name := 'Base';
  Group := 'Misc';
end;

procedure TBaseObj.PlaySnd(AName: string);
begin
  if OnScreen then
   if AName<>'' then 
    SoundMgr.GetSnd(AName, TSample).Play;
end;

procedure TBaseObj.SaveToStream(S: TStream);
var
  i: long;
begin
  SaveUnMod(S);
  SaveMod(S);
end;

procedure TBaseObj.SaveUnMod(S: TStream);
begin
  WriteStr(S, Name);
  S.WriteBuffer(Bounds.Left, SizeOf(Bounds.Left));
  S.WriteBuffer(Bounds.Top, SizeOf(Bounds.Top));

end;

procedure TBaseObj.SaveMod(S: TStream);
begin
  S.WriteBuffer(Bounds.Right, SizeOf(Bounds.Right));
  S.WriteBuffer(Bounds.Bottom, SizeOf(Bounds.Bottom));
  WriteStr(S, Texture.Name);
  S.WriteBuffer(Z, SizeOf(Z));
  S.WriteBuffer(Color, SizeOf(Color));
  S.WriteBuffer(Speed, Sizeof(Speed));
  S.WriteBuffer(FWidth, Sizeof(Fwidth));
  S.WriteBuffer(FHeight, Sizeof(FHeight));
  S.WriteBuffer(Rate, SizeOf(Rate));
  S.WriteBuffer(CanAnim, SizeOf(CanAnim));
  S.WriteBuffer(Blend, SizeOf(Blend));
end;

procedure TBaseObj.LoadFromStream(S: TStream);
var
  i: long;
begin
  LoadUnMod(S);
  LoadMod(S)

end;

procedure TBaseObj.LoadUnMod(S: TStream);
begin
  Name := ReadStr(S);
  S.ReadBuffer(Bounds.Left, SizeOf(Bounds.Left));
  S.ReadBuffer(Bounds.Top, SizeOf(Bounds.Top));

end;


procedure TBaseObj.LoadMod(S: TStream);
begin
  S.ReadBuffer(Bounds.Right, SizeOf(Bounds.Right));
  S.ReadBuffer(Bounds.Bottom, SizeOf(Bounds.Bottom));
  Texture.Name := ReadStr(S);
  S.ReadBuffer(Z, SizeOf(Z));
  S.ReadBuffer(Color, SizeOf(Color));
  S.ReadBuffer(Speed, Sizeof(Speed));
  S.ReadBuffer(FWidth, Sizeof(Fwidth));
  S.ReadBuffer(FHeight, Sizeof(FHeight));
  S.ReadBuffer(Rate, SizeOf(Rate));
  S.ReadBuffer(CanAnim, SizeOf(CanAnim));
  S.ReadBuffer(Blend, SizeOf(Blend));
end;


function TBaseObj.Clone(recreate: boolean): TBaseObj;
var
  MS: TMS;
  Clon: TBaseObj;

begin
  Clon := TEngObjClass(FindClass(Self.ClassName)).Create(Device, Bounds, Texture, Color, Z, true);

  MS := TMS.Create;

  Self.SaveUnMod(MS);
  Self.SaveMod(MS);
  MS.Position := 0;

  Clon.LoadUnMod(MS);
  Clon.LoadMod(MS);
  Clon.Modified := Modified;
  if recreate then Init;

  Result := Clon;
  MS.Free;
end;

procedure TBaseObj.LoadFromInfo(I:TBaseInfo);
begin
 Name:=I.Name;
 Speed:=I.Speed;
 Blend:=I.Blend;
 FWidth:=I.FWidth;
 FHeight:=I.FHeight;
 Color:=I.Color;
 Z:=I.Z;
 Texture:=TexMgr.GetTex(I.TexName,LT_LEVEL);
 Bounds:=Rect(I.X,I.Y,I.Width,I.Height);


end;
////////////////// TBACKROUND //////////


constructor TBackGround.Create(ADev: IDevice;
  ABounds: TRect; Tex: TDXTexture;
  AColor: TD3DColor; AZ: long; AInit: boolean);
begin
  inherited Create(ADev, ABounds, Tex, AColor, AZ, AInit);

end;

procedure TBackGround.SetDefaults;
begin
  inherited;
  Name := 'Back';
  Group := 'BackGrounds';
  if Z = Z_DEF then
    Z := Z_BACK;
  Speed := SP_MainBACK;

end;


procedure TBackGround.DoMove;
var
  Desc: TD3DSurface_Desc;
begin
  inherited;
  if Eng.MoveStopped then Exit;

  if (th=0)or(tw=0) then
  begin
  if Texture.Tex = nil then Exit;
  Texture.Tex.GetLevelDesc(0, Desc);
  tw := Desc.Width;
  th := Desc.Height;

  minu := 0;
  maxu := (th / tW) * (Bounds.Right div Bounds.Bottom);

  if tW >= tH then
    speed_u := speed * (tH / tW) * 2
  else
    speed_u := speed * (tH / tW) * (Bounds.Right div Bounds.Bottom); ;

  SetUV(minu, MIN_V, maxu, MAX_V, true);
  end;

  minu := minu + speed_u;
  maxu := maxu + speed_u;

  SetUV(minu, MIN_V, maxu, MAX_V, true);


end;

{function TBackGround.Clone:TBaseObj;
begin
 Result:=TBaseObj(inherited);
 TBackGround(Result).maxu:=maxu;
 TBackGround(Result).minu:=minu;

end;
 }


//////////////////////  TCOLOBJ

constructor TColObj.Create(ADev: IDevice;
  ABounds: TRect; Tex: TDXTexture;
  AColor: TD3DColor; AZ: long; AInit: boolean);
begin
  inherited Create(ADev, ABounds, Tex, AColor, AZ, AInit);
  SetAnim(FWidth, FHeight, SP_ANIRATE, Animed);


end;

procedure TColObj.SetDefaults;
begin
  inherited;
  Name := 'ColObj';
  Group := 'Misc';

  Speed := SP_World;
  Block := bk_Block;

end;


procedure TColObj.DoMove;
begin
  inherited;
end;

procedure TColObj.Move(x, y: single);
begin
  cx := x;
  cy := y;
  TestCol;
  inherited Move(cx, cy);

end;

procedure TColObj.TestCol;
begin

end;

procedure TColObj.DoCol(Obj: TColObj);
begin



end;


procedure TColObj.LoadFromInfo(I:TBaseInfo);
var II:TColObjInfo;
begin
 inherited;
 II:=TColObjInfo(I);
 Block:=II.Block;
 Animed:=II.Animed;

 SetAnim(FWidth,FHeight,SP_ANIRATE,Animed);
end;

{function TColObj.Clone:TBaseObj;
begin
 inherited;
 TColObj(Result).Block:=Block;

end;
 }
/////////////////////////////////

procedure TDecor.SetDefaults;
begin
  inherited;
  Name := 'Decor';
  Group := 'Decors';

  if Z = Z_DEF then
    Z := Z_DECOR;
  Speed := SP_World;
end;



procedure TDecor.DoMove();
begin
  inherited;
  if Eng.MoveStopped then
    Move(0, 0)
  else
    Move(Speed, 0);

end;

procedure TDecor.DoCol(Obj: TColObj);
begin
  if Block=bk_Block then TProjectile(Obj).Deaded := true;
end;

procedure TDecor.TestCol;
var
  i: long;
begin
  inherited;
  if not OnScreen then Exit;
  if Deaded then Exit;
  if not Visible then Exit;


  for i := 0 to Eng.Objects.Count - 1 do
    if not (Eng.Objects[i] is TProjectile) then
      Continue
    else if not TBaseObj(Eng.Objects[i]).OnScreen then
      Continue
    else if (TColObj(Eng.Objects[i]).Deaded) then
      Continue
    else if not (TColObj(Eng.Objects[i]).Visible) then
      Continue
    else if OverlapRect(GetRect, TColObj(Eng.Objects[i]).GetRect)
      then
      DoCol(TColObj(Eng.Objects[i]));




end;




{function TDecor.Clone:TBaseObj;
begin
 inherited;
end;
 }
//////////////////////  TENTITY

constructor TEntity.Create(ADev: IDevice;
  ABounds: TRect; Tex: TDXTexture;
  AColor: TD3DColor; AZ: long; AInit: boolean);
begin
  inherited Create(ADev, ABounds, Tex, AColor, AZ, AInit);

end;

procedure TEntity.SetDefaults;
begin
  inherited;
  Name := 'Entity';
  Group := 'Misc';

  if Z = Z_DEF then
    Z := Z_ENTITY;
  sndFire := '';
  sndDie := '';
  sndHit := '';
  sndAmb := '';

  Animed:=true;
end;

procedure TEntity.DoFire;
begin
  PlaySnd(sndFire);

end;

procedure TEntity.TestCol;
var
  i: long;
begin
  inherited;
  if not OnScreen then Exit;
  if Deaded then Exit;
  if not Visible then Exit;


  for i := 0 to Eng.Objects.Count - 1 do
    if not TBaseObj(Eng.Objects[i]).OnScreen then
      Continue
    else if not (Eng.Objects[i] is TColObj) then
      Continue
    else if (TColObj(Eng.Objects[i]).Deaded) then
      Continue
    else if not (TColObj(Eng.Objects[i]).Visible) then
      Continue
    else if OverlapRect(GetRect, TColObj(Eng.Objects[i]).GetRect)
      then
      DoCol(TColObj(Eng.Objects[i]));




end;

procedure TEntity.DoCol(Obj: TColObj);
var
  Pos: TPoint;
  dR: TREct;
  dx, dy: long;
begin
  inherited;
  Pos := GetPos;

  if (Obj is TDecor) then
  begin
    case TDecor(Obj).Block of
      bk_Block:
        begin
          dr := GetRect;
          CliPRect(dR, Obj.GetRect);
          dx := dr.Right - dr.Left;
          dy := dr.Bottom - dr.Top;

          if cx < 0 then
            if ((Pos.X + cx - 5) < (Obj.GetPos.X + Obj.Bounds.Right))
              and (not (dy in [0..10])) then cx := 0;

          if cx > 0 then
            if ((Pos.X + cx + Bounds.Right) > Obj.GetPos.X - 5) and (not (dy in [0..10]))
              and ((Pos.X + cx) < Obj.GetPos.x)

            then cx := -dx;


          if cy < 0 then
            if ((Pos.Y + cy) > (Obj.GetPos.Y)) and
              ((Pos.Y + cy) < (Obj.GetPos.Y + Obj.Bounds.Bottom))
              then cy := 0;

          if cy > 0 then
            if ((Pos.Y + cy + Bounds.Bottom) > Obj.GetPos.Y)
              and ((Pos.Y + cy) < (Obj.GetPos.Y + Obj.Bounds.Bottom - 10))
              then
              cy := 0;

        end;

    end;
  end;




end;


procedure TEntity.Kill;
begin
  PlaySnd(sndDie);

end;


procedure TEntity.LoadFromInfo(I:TBaseInfo);
var II:TEntityInfo;
begin
 inherited;
 II:=TEntityInfo(I);
 Ranged:=WeaponMgr.Get(II.WRanged);
 Melee:=WeaponMgr.Get(II.WMelee);
 Armor:=ArmorMgr.Get(II.Armor);
 MaxHP:=II.HP;
 HP:=II.HP;
 XP:=II.XP;
 sndFire:=II.sndFire;
 sndDie:=II.sndDie;
 sndHit:=II.sndHit;
 sndAmb:=II.sndAmb;

 end;


function TEntity.OnScreen: boolean;
var newo:boolean;
begin
 newO:=inherited OnScreen;
 if (foldonscr=false)and(newo=true) then Eng.AddMsg(Format('Prv jsi spatil: %s',[Name]));
 foldonscr:=newO;
 Result:=newO;



end;

{function TEntity.Clone:TBaseObj;
var Ent:TEntity;
begin
 inherited;
 Ent:=TEntity(Result);
 Ent.FHP:=HP;
 Ent.FCad:=FCad;
 Ent.XP:=XP;
 Ent.sndFire:=sndFire;
 Ent.sndHit:=sndHit;
 Ent.sndDie:=sndDie;
 Ent.sndAmb:=sndAmb;

end;
}


//////////////////////  TENEMY

constructor TEnemy.Create(ADev: IDevice;
  ABounds: TRect; Tex: TDXTexture;
  AColor: TD3DColor; AZ: long; AInit: boolean);
begin
  inherited Create(ADev, ABounds, Tex, AColor, AZ, AInit);


end;

procedure TEnemy.SetDefaults;
begin
  inherited;
  Name := 'Enemy';
  Speed := -2.9;
  XP := 150;
  MaxHP := 6;
  HP:=6;
  FWidth := 64;
  FHeight := 32;
  Group := 'Enemies';

  Ranged := WeaponMgr.Get('Hrouda slizu');
  Melee := WeaponMgr.Get('Drpy');
  Armor := ArmorMgr.Get('Ke');

  sndFire := 'ingame\enemy_fire.wav';
  sndDie := 'ingame\enemy_die.wav';
  sndHit := 'ingame\enemy_hit.wav';
  sndAmb := 'ingame\enemy_amb.wav';


end;


procedure TEnemy.DoMove;
begin
  inherited;
  if not Eng.MoveStopped then
  begin
    if OnScreen then
    begin Move(speed, 0); DoFire;
    end
    else
      Move(SP_WORLD, 0);
  end
  else
  begin
    if OnScreen then
    begin Move(speed, 0); DoFire;
    end
    else
      Move(0, 0);
  end;


end;

procedure TEnemy.DoFire;
var
  Pr: TProjectile;
begin
  if not OnScreen then Exit;
  if Ranged <> nil then
    if GetTickCount > Tag3 + 1000 / Ranged.cadence then
    begin
      inherited;

      Pr := TProjectile(Eng.Add(TProjectile.Create(Device, Rect(GetRect.Left, (Bounds.Bottom - 32) div 2 + GetRect.Top, Ranged.pWidth, Ranged.pHeight), TexMgr.GetTex(Ranged.Tex))));
      Pr.Speed := -Ranged.pSpeed;
      Pr.Damage := Ranged.Damage;
      Pr.Gunner := gn_Enemy;
      Pr.Blend := Ranged.Blend;
      Tag3 := GetTickCount;
    end;

end;


procedure TEnemy.SetHP(Value: long);
begin
  FHP := Min(Value,MaxHP);
  if HP <= 0 then Kill;

end;

procedure TEnemy.DoCol(Obj: TColObj);
begin
  inherited;

  if (Obj is TProjectile) then
    if (TProjectile(Obj).Gunner = gn_player) then
    begin
      PlaySnd(sndHit);
      Attacker := TProjectile(Obj).Owner;
      Obj.Deaded := true;
      HP := HP - TProjectile(Obj).damage;
    //  SetColor(D3DCOLOR_RGBA($FF, HP * 15 + 20, Hp * 15 + 20, $FF));


    end;


end;

procedure TEnemy.Kill;
begin
  inherited;
  Deaded := true;
  if Attacker <> nil then begin Attacker.XP := Attacker.XP + Self.XP;Inc(TPlayer(Attacker).Kills);end;
  Eng.AddMsg(Format('Neptel zemel: %s , %s obdr %d XP',[name,Attacker.Name,Self.XP]));

end;

{function TEnemy.Clone:TBaseObj;
begin
 inherited;

end;
}

////////////////  TBOSS

procedure TBoss.DoMove;
var Pos:tvector2;
begin
  if OnScreen then DoTimer;



 // if not Eng.MoveStopped then

  begin
  if OnScreen then
  begin
    Eng.StopMove;
    Stopped:=true;


     if GetRect.Right > Eng.Dim.X then
     Move(speed, 0)
    else
     begin
      Pos := GetRealPos;
      if FAscend then ay:=speed
       else ay:=-speed;
      cx:=0;
      cy:=ay;
      if ((Pos.Y + cy) < Eng.Sky - 50) or ((Pos.Y + cy) > (Eng.Dim.Y - Eng.Ground) - Bounds.Bottom) then cy := 0;
      TestCol;
      if cy<>ay then FAscend:=not FAscend;
      if FAscend then
       cx:=cx;

      Move2D(0, cy);

     end;

    DoFire;
  end
  else
    if not Stopped then
    Move(SP_WORLD, 0)
    else
   //  if Stopped and (Abs(Eng.Dim.X-GetRect.Right)>50)then
      Move(0, 0)
    //  else;

  end
  // else
  //  Move(0, 0);

end;


procedure TBoss.SetDefaults;
begin
  inherited;
  HP := 30;
  XP:=1000;
  if Z=Z_DEF then
  Z:=Z_BOSS;
  Ranged := WeaponMgr.Get('Fireball');



end;

procedure TBoss.Kill;
begin
  inherited;
  Eng.ResumeMove;
  Stopped:=false;
end;


//////////////////////  TPLAYER

constructor TPlayer.Create(ADev: IDevice;
  ABounds: TRect; Tex: TDXTexture;
  AColor: TD3DColor; AZ: long; AInit: boolean);
begin
  inherited Create(ADev, ABounds, Tex, AColor, AZ, AInit);

end;

procedure TPlayer.SetDefaults;
begin
  inherited;
  Name := 'Player';
  Group := 'Players';

  Speed := 4.0;
  MaxHP:=15;
  HP := 15;
  XP := 0;
  FWidth := 64;
  FHeight := 32;
  if Z = Z_DEF then
    Z := Z_PLAYER;

  Ranged := WeaponMgr.Get('Vrhac noe');
  RangedB := WeaponMgr.Get('Fireball');
  Melee := WeaponMgr.Get('Dka');
  Armor := ArmorMgr.Get('Vycpvan zbroj');


  sndFire := 'ingame\player_fire.wav';
  sndDie := 'ingame\player_die.wav';
  sndHit := 'ingame\player_hit.wav';
  sndAmb := 'ingame\enemy_amb.wav';

  I_Left := VK_LEFT;
  I_Right := VK_RIGHT;
  I_Up := VK_UP;
  I_Down := VK_DOWN;
  I_Fire := VK_SHIFT;
  I_Fire2 := VK_CONTROL;


end;



procedure TPlayer.CheckInput;
begin
  inherited;

  if IsKeyDown(I_LEFT) then Move(-round(speed), 0);
  if IsKeyDown(I_RIGHT) then Move(round(speed), 0);
  if IsKeyDown(I_UP) then Move(0, -round(speed));
  if IsKeyDown(I_DOWN) then Move(0, round(speed));
  if IsKeyDown(I_FIRE)or IsKeyDown(I_FIRE2)  then DoFire;


end;

procedure TPlayer.DoMove;
begin
  inherited;
  Move(0.0001, 0);

end;

procedure TPlayer.Move(x, y: single);
var
  Pos: TVector2;
begin
  Pos := GetRealPos;

  if ((Pos.X + x) < 0) or ((Pos.X + x) > Eng.Dim.X - Bounds.Right) then x := 0;

  inherited;

  if GetPos.X < 0 then Move(-Getpos.X, 0);

end;

procedure TPlayer.DoFire;
var
  Pr: TProjectile;
  W:TWeapon;
begin
  if IsKeyDown(I_FIRE) then  W:=Ranged
  else if IsKeyDown(I_FIRE2) then W:=RangedB
  else Exit;


  if GetTickCount > Tag3 + 1000 / W.Cadence then
  begin
    inherited;

    Pr := TProjectile(Eng.Add(TProjectile.Create(Device,
      Rect(GetRect.Right, (Bounds.Bottom - 32) div 2 + GetRect.Top, W.pWidth, W.pHeight), TexMgr.GetTex(W.Tex))));
    Pr.Owner := Self;
    Pr.Damage := W.Damage;
    Pr.Gunner := gn_player;
    Pr.Speed := W.pSpeed;
    Pr.Blend := W.Blend;
    Tag3 := GetTickCount;
  end;



end;


procedure TPlayer.SetHP(Value: long);
begin
  FHP := Min(Value,MaxHP);
  if HP <= 0 then Kill;

end;



procedure TPlayer.DoCol(Obj: TColObj);
begin
  inherited;
  if (Obj is TProjectile) then
    if (TProjectile(Obj).Gunner = gn_Enemy) then
    begin
      Obj.Deaded := true;
      HP := HP - TProjectile(Obj).Damage;
      PlaySnd(sndHit);
     // SetColor(D3DCOLOR_RGBA($FF, HP * 15 + 20, Hp * 15 + 20, $FF));

    end;

  if (Obj is TEnemy) then
  begin
    if GetTickCount > Tag2 + 150 then
    begin
      //Obj.SetColor(D3DCOLOR_RGBA($FF, TEnemy(Obj).HP * 15 + 20, TEnemy(Obj).Hp * 15 + 20, $FF));
      //SetColor(D3DCOLOR_RGBA($FF, HP * 15 + 20, Hp * 15 + 20, $FF));
      PlaySnd(sndHit);
      TEntity(Obj).PlaySnd(TEntity(Obj).sndHit);
      TEnemy(Obj).Attacker:=Self;
      Hp := Hp - TEnemy(Obj).Melee.damage;
      TEntity(Obj).Hp := TEntity(Obj).Hp - Melee.Damage;
      Tag2 := GetTickCount;
    end;

  end;




end;

procedure TPlayer.Kill;
var List:TStringList;
begin
  inherited;
  List:=TStringList.Create;
  List.Add(Format('[%s] byl zavradn na malilinkat kousky.', [Name]));
  List.Add('Ml jsem ho docela rd, tak ho obivm, avak');
  List.Add(Format('vypjm si od nj %d  XP', [CS_DEATH]));
  ShowMsg(List, 'Smrt si t nala', 'MOD_ENGINESTOP',true);
  List.Free;
  Eng.Stop;

  Inc(Deaths);
  XP:=XP-CS_DEATH;
  HP := MaxHP;
end;


procedure TPlayer.LoadFromInfo(I:TBaseInfo);
var II:TPlayerInfo;
begin
 inherited;
 II:=TPlayerInfo(I);
 RangedB:=WeaponMgr.Get(II.WRangedB);
 I_Left:=II.I_left;
 I_right:=II.I_right;
I_up:=II.I_up;
I_down:=II.I_down;
I_fire:=II.I_fire;
I_fire2:=II.I_fire2;

ImgCol:=II.ImgCol;
end;


{function TPlayer.Clone:TBaseObj;
begin
 inherited;

end;
}

////////////////////////  TPROJECTILE

constructor TProjectile.Create(ADev: IDevice;
  ABounds: TRect; Tex: TDXTexture;
  AColor: TD3DColor; AZ: long; AInit: boolean);
begin
  inherited Create(ADev, ABounds, Tex, AColor, AZ, AInit);

end;

procedure TProjectile.SetDefaults;
begin
  inherited;
  Name := 'Projectile';
  Group := 'Projectiles';

  Speed := 3;
  ActRange := 0;
  MaxRange := 800;
  if Z = Z_DEF then
    Z := Z_PROJECTILE;

end;


procedure TProjectile.DoMove;
begin
  inherited;
  Move(speed, 0);
  ActRange := ActRange + Abs(speed);

  if ActRange > MaxRange then Deaded := true;


end;

{function TProjectile.Clone:TBaseObj;
begin
 inherited;
 TProjectile(Result).Actrange:=ActRange;
 TProjectile(Result).Maxrange:=MaxRange;
 TProjectile(Result).Gunner:=Gunner;
 TProjectile(Result).Owner:=Owner;
 


end;

 }


//////////////////////  INFOS


/////////////// TBASEINFO
constructor TBaseInfo.Create;
begin
 inherited Create;
 SetDefaults;

end;

procedure TBaseInfo.SetDefaults;
begin
  Name := 'Base';
  Group := 'Misc';
  Color:=$FFFFFFFF;
  Z:=-100;
  TexName:='editor\obj.png';
end;

function GetGroup(Obj: TBaseInfo): string;
begin
  Result := 'Misc';
  if CompStr(Obj.ClassName, 'TEnemyInfo') then Result := 'Enemies';
  if CompStr(Obj.ClassName, 'TDecorInfo') then Result := 'Decors';
  if CompStr(Obj.ClassName, 'TBackgroundInfo') then Result := 'BackGrounds';
  if CompStr(Obj.ClassName, 'TBossInfo') then Result := 'Bosses';
  if CompStr(Obj.ClassName, 'TPlayerInfo') then Result := 'Players';


end;



procedure TBaseInfo.Load(S: TStream);
begin
Group:=GetGroup(Self);


Name:=ReadStr(S);
S.ReadBuffer(X,SizeOf(X));
S.ReadBuffer(Y,SizeOf(Y));


TexName:=ReadStr(S);
S.ReadBuffer(Width,SizeOf(Width));
S.ReadBuffer(Height,SizeOf(Height));
S.ReadBuffer(Z,SizeOf(Z));
S.ReadBuffer(Color,SizeOf(Color));
S.ReadBuffer(Speed,SizeOf(Speed));
S.ReadBuffer(FWidth,SizeOf(FWidth));
S.ReadBuffer(FHeight,SizeOf(FHeight));
S.ReadBuffer(Blend,SizeOf(Blend));



end;

procedure TBaseInfo.Save(S: TStream);
begin
WriteStr(S,Name);
S.WriteBuffer(X,SizeOf(X));
S.WriteBuffer(Y,SizeOf(Y));


WriteStr(S,TexName);
S.WriteBuffer(Width,SizeOf(Width));
S.WriteBuffer(Height,SizeOf(Height));
S.WriteBuffer(Z,SizeOf(Z));
S.WriteBuffer(Color,SizeOf(Color));
S.WriteBuffer(Speed,SizeOf(Speed));
S.WriteBuffer(FWidth,SizeOf(FWidth));
S.WriteBuffer(FHeight,SizeOf(FHeight));
S.WriteBuffer(Blend,SizeOf(Blend));



end;


function TBaseInfo.Clone:TBaseInfo;
var
  MS: TMS;
  Clon: TBaseInfo;

begin
  Clon := TEngObjInfo(FindClass(Self.ClassName)).Create;
  MS := TMS.Create;
  Self.Save(MS);
  MS.Position := 0;
  Clon.Load(MS);
  Result := Clon;
  MS.Free;

end;

/////////////// TBACKINFO
procedure TBackGroundInfo.SetDefaults();
begin
inherited;
  Name := 'Back';
  Group := 'BackGrounds';
  Z := Z_BACK;
  Speed := SP_MainBACK;
  Width:=800;
  Height:=600;

end;


procedure TBackgroundInfo.Load(S: TStream);
begin
inherited;
end;

procedure TBackgroundInfo.Save(S: TStream);
begin
inherited;
end;


/////////////// TCOLOBJINFO
procedure TColObjInfo.SetDefaults();
begin
inherited;
Name := 'ColObj';
Speed := SP_World;
Block := bk_Block;

end;


procedure TColObjInfo.Load(S: TStream);
begin
inherited;
S.ReadBuffer(Block,SizeOf(Block));
S.ReadBuffer(Animed,SizeOf(Animed));

end;

procedure TColObjInfo.Save(S: TStream);
begin
inherited;
S.WriteBuffer(Block,SizeOf(Block));
S.WriteBuffer(Animed,SizeOf(Animed));

end;

/////////////// TDECORINFO
procedure TDecorInfo.SetDefaults();
begin
inherited;
Name:='Decor';
Group:='Decors';
Z := Z_DECOR;
Width:=128;
Height:=128;
end;


procedure TDecorInfo.Load(S: TStream);
begin
inherited;
end;

procedure TDecorInfo.Save(S: TStream);
begin
inherited;
end;


/////////////// TENTITYINFO
procedure TEntityInfo.SetDefaults();
begin
inherited;
 Name := 'Entity';
 Z := Z_ENTITY;
 sndFire := 'ingame\enemy_fire.wav';
 sndDie := 'ingame\enemy_die.wav';
 sndHit := 'ingame\enemy_hit.wav';
 sndAmb := 'ingame\enemy_amb.wav';

 Animed:=true;
end;


procedure TEntityInfo.Load(S: TStream);
begin
inherited;

WRanged:=ReadStr(S);
WMelee:=ReadStr(S);
Armor:=ReadStr(S);
sndFire:=ReadStr(S);
sndDie:=ReadStr(S);
sndHit:=ReadStr(S);
sndAmb:=ReadStr(S);;

S.ReadBuffer(HP,SizeOf(HP));
S.ReadBuffer(Xp,SizeOf(XP));


end;

procedure TEntityInfo.Save(S: TStream);
begin
inherited;

WriteStr(S,WRanged);
WriteStr(S,WMelee);
WriteStr(S,Armor);
WriteStr(S,sndFire);
WriteStr(S,sndDie);
WriteStr(S,sndHit);
WriteStr(S,sndAmb);

S.WriteBuffer(HP,SizeOf(HP));
S.WriteBuffer(Xp,SizeOf(XP));



end;

/////////////// TENEMYINFO
procedure TEnemyInfo.SetDefaults();
begin
inherited;
  Name := 'Enemy';
  Group:='Enemies';
  Speed := -3;
  XP := 150;
  HP := 6;
  FWidth := 64;
  FHeight := 32;
  Width:=128;
  Height:=64;

  WRanged := ('Hrouda slizu');
  WMelee := ('Drpy');
  Armor := ('Ke');

  sndFire := 'ingame\enemy_fire.wav';
  sndDie := 'ingame\enemy_die.wav';
  sndHit := 'ingame\enemy_hit.wav';
  sndAmb := 'ingame\enemy_amb.wav';

end;


procedure TEnemyInfo.Load(S: TStream);
begin
inherited;
end;

procedure TEnemyInfo.Save(S: TStream);
begin
inherited;
end;

/////////////// TBOSSINFO
procedure TBossInfo.SetDefaults();
begin
inherited;
Name:='Boss';
Group:='Bosses';
Width:=128;
Height:=256;
FWidth := 64;
FHeight := 128;
HP := 30;
XP:=1000;
WRanged := ('Fireball');
Animed:=true;
Z:=Z_BOSS;
end;

procedure TBossInfo.Load(S: TStream);
begin
inherited;
end;

procedure TBossInfo.Save(S: TStream);
begin
inherited;
end;

/////////////// TPLAYERINFO
procedure TPlayerInfo.SetDefaults();
begin
inherited;
 Name := 'Player';
 Group:='Players';
  Speed := 4.0;
  HP := 15;
  XP := 0;
  FWidth := 64;
  FHeight := 32;
  Z := Z_PLAYER;
  Width:=128;
  height:=64;

  WRanged := ('Vrhac noe');
  WRangedB := ('Fireball');
  WMelee := ('Dka');
  Armor := ('Vycpvan zbroj');
 Animed:=true;

  sndFire := 'ingame\player_fire.wav';
  sndDie := 'ingame\player_die.wav';
  sndHit := 'ingame\player_hit.wav';
  sndAmb := 'ingame\enemy_amb.wav';

  I_Left := VK_LEFT;
  I_Right := VK_RIGHT;
  I_Up := VK_UP;
  I_Down := VK_DOWN;
  I_Fire := VK_SHIFT;
  I_Fire2 := VK_CONTROL;

end;

procedure TPlayerInfo.Load(S: TStream);
begin
inherited;
WRangedB:=ReadStr(S);
S.ReadBuffer(I_left,SizeOf(I_left));
S.ReadBuffer(I_right,SizeOf(I_right));
S.ReadBuffer(I_up,SizeOf(I_up));
S.ReadBuffer(I_down,SizeOf(I_down));
S.ReadBuffer(I_fire,SizeOf(I_fire));
S.ReadBuffer(I_fire2,SizeOf(I_fire2));


end;

procedure TPlayerInfo.Save(S: TStream);
begin
inherited;

WriteStr(S,WRangedB);
S.WriteBuffer(I_left,SizeOf(I_left));
S.WriteBuffer(I_right,SizeOf(I_right));
S.WriteBuffer(I_up,SizeOf(I_up));
S.WriteBuffer(I_down,SizeOf(I_down));
S.WriteBuffer(I_fire,SizeOf(I_fire));
S.WriteBuffer(I_fire2,SizeOf(I_fire2));


end;

procedure TPlayerInfo.SetPos(x,y:long);
begin
 Self.X:=x;
 Self.Y:=y;
end;


initialization

  RegisterClasses([TBaseObj, TColObj, TEntity, TEnemy, TPlayer, TBackGround,TBoss, TDecor, TProjectile,
    TBaseInfo, TBackGroundInfo, TDEcorInfo, TEnemyInfo, TBossInfo, TPlayerInfo
    ]);




end.

