{
  Drake Rider

  (C) 2002 Vampyre SoftWorks
  Created by :  Marek Mauder  
}	


unit Errors;

interface

uses Windows, SysUtils;

const

  ERR_D3DNOTCREATED = 1;
  ERR_DEVINITFAIL = 2;
  ERR_CREATEOBJ = 3;
  ERR_DEVRESET = 4;
  ERR_TEXLOAD = 5;
  ERR_SETCURSOR = 6;
  ERR_NOT32BITTEX = 7;
  ERR_TEXCONV = 8;
  ERR_SAMPLELOAD = 9;
  ERR_TEXTENTRY=10;

  
type

  AppError = Exception;


procedure ShowError(Code: dword);



implementation

procedure ShowError(Code: dword);
var
  s: string;
begin
  s := 'Unknown Error';
  case Code of
    ERR_D3DNOTCREATED: s := 'D3D interface not created.';
    ERR_DEVINITFAIL: s := 'D3D Device initialization failed.';
    ERR_CREATEOBJ: s := 'Error when creating DX object.';
    ERR_DEVRESET: s := 'D3D Device reset failed.';
    ERR_TEXLOAD: s := 'Error when loading texture.';
    ERR_SETCURSOR: s := 'Error when setting device cursor.';
    ERR_NOT32BITTEX: s := 'Tex->Bmp convert error.Not a 32 bit Texture.';
    ERR_TEXCONV: s := 'Error whern converting texture.';
    ERR_SAMPLELOAD: s := 'Error when loading sample.';
    ERR_TEXTENTRY:s:='Invalid text Entry.';
    
  end;

  raise AppError.Create(s);
end;


end.

