{
  Drake Rider

  (C) 2002 Vampyre SoftWorks
  Created by :  Marek Mauder  
}	


unit MainGame;

interface

uses Windows, Classes, SysUtils,  DirectXGraphics,VTextList,Controls,
  D3DX8, gameTypes, Errors, Graphics, WinFunc, DIB, Forms;

var

  TextList:TTextList;
  CampText:TTextList;

  Debug:boolean = not  true;

  GfxOpt: TGfxOpt;
  d3dpp:td3dpp;

const

   // game states
  ST_SPLASH = 0;
  ST_ANILOGO = 1;
  ST_MAINMENU = 2;
  ST_NEWGAME=3;
  ST_CREDITS=4;
  ST_INTERGAME=5;
  ST_ENDGAME=6;
  ST_INGAME = 10;

  // other
  SP_ANIRATE=8;


  /// colors
  BTN_OrigCol = $BBDDDDDD;
  BTN_MouseCol = $EEFFAAAA;
  BTN_ClickCol = $FFFFEE99;

  WIN_OrigCol = $EEFFEEEE;
  WIN_MouseCol = $EEFFEEEE;
  WIN_ClickCol = $EEFFEEEE;

  FNT_DefCol = $FFFFFFA0;
  FNT_INgCol=$FFFFFF99;
  FNT_LabCol = $FFFFFF50;
  FNT_MsgCol=$FFFFFF11;
  FNT_StoryCol=$FFFFDD00;


  COL_TRANS=$FFFF00FF;



  BTN_TRANSLATE: long = 1;

const
  /// VERSION
  sVersion = '< Drake Rider >  Version 0.77  15/11/2002';
  VerHI=0;
  VerLO=77;


  // MAXES

  MAX_FONTS = 13;
  MAX_PLAYERS = 4;
  MAX_PLCOLS=15;

  ///////// MSGS

  MSG_MOUSEFIRST = 100;
  MSG_CLICKED = 101;
  MSG_MOUSEDOWN = 102;
  MSG_MOUSEUP = 103;
  MSG_MOUSEENTER = 104;
  MSG_MOUSELEAVE = 105;


  MSG_MOUSELAST = 199;

  MSG_FADEDIN = 200;
  MSG_FADEDOUT = 201;
  MSG_SHOW=300;

  MSG_MODAL=1000;

  
 //////// LOAD MGR TAGS
  LT_GUI_FIXED = 0;
  LT_GUI_MOVABLE = 1;
  LT_ANILOGO = 2;
  LT_LEVEL = 3;

  /////  MISC TIMES

  FADE_POWER = 5;
  FADE_FAST = 5;
  FADE_SLOW = 40;
  FADE_INT = FADE_FAST;

  //// gui sizes
  MB_W = 192;
  MB_H = 48;

  SB_W = 128;
  SB_H = 32;

  BB_W = 256;
  BB_H = 64;


  /// costs
  CS_HP=1000;
  CS_SPD=2500;
  CS_DEATH=500;


type

  TFontInfo = record
    Name: string;
    Size: long;
    Color: TD3DColor;
    Style: TFontStyles;

  end;

  TFonts = array[0..MAX_FONTS - 1] of TFontInfo;


const
  Fonts: TFonts = (
    (Name: 'Orea'; Size: 20; Color: FNT_DefCol; Style: [fsBold]),
    (Name: 'Orea'; Size: 30; Color: FNT_LabCol; Style: [fsBold]),
    (Name: 'Orea'; Size: 24; Color: FNT_DefCol; Style: [fsBold]),
    (Name: 'Calligraphia'; Size: 12; Color: FNT_DefCol; Style: [fsBold]),
    (Name: 'Calligraphia'; Size: 8; Color: FNT_StoryCol; Style: [fsBold]),
    (Name: 'Calligraphia'; Size: 11; Color: FNT_IngCol; Style: [fsBold]),
    (Name: 'Calligraphia'; Size: 11; Color: FNT_StoryCol; Style: [fsBold]),
    (Name: 'Calligraphia'; Size: 11; Color: FNT_DefCol; Style: [fsBold]),
    (Name: 'Orea'; Size: 18; Color: FNT_DefCol; Style: [fsBold]),
    (Name: 'Calligraphia'; Size: 11; Color: FNT_MsgCol; Style: [fsBold]),

    (Name: 'Calligraphia'; Size: 17; Color: FNT_DefCol; Style: [fsBold]),
    (Name: 'Orea'; Size: 18; Color: FNT_DefCol; Style: [fsBold]),
    (Name: 'Calligraphia'; Size: 11; Color: FNT_MsgCol; Style: [fsBold])


    );

// fonts
  FN_MEDBTN = 0;
  FN_SCRLABEL = 1;
  FN_SMBTN_L = 2;
  FN_OPT = 3;
  FN_EDIT = 4;
  FN_MSG=7;
  FN_TXTWIN=9;
  FN_MSGLAB=8;
  FN_STORY=6;
  FN_ING=5;
  FN_PLSTAT  =10;

// PLAYER COLORS

type

     TPLColors=array[0..MAX_PLCOLS-1]of dword;

const

     PLColors:TPLColors=(
     $FFFF0000,
     $FF0000FF,
     $FF00FF00,
     $FF00FFFF,
     $FF999999,
     $FFFFFF00,
     $FF000000,
     $FFFE00FF,
     $FF865F2C,
     $FFFFFFFF,

     $FF008000,
     $FF800000 ,
     $FF808000  ,
     $FF000080   ,
     $FFFA48B1

     );


///// files
const
 FL_OBJS='data\obj\objects.drd';
 FL_CAMP='data\obj\campaign.drd';
 FL_WEAPONS='data\obj\weapons.drd';
 FL_ARMORS='data\obj\armors.drd';


type
  TLoadFile = record
    Name: string;
    Size: dword;
    Bytes: Pointer;
  end;

function LoadFile(Name: string): TLoadFile;
procedure FreeFile(F: TLoadFile);
function LoadTexture(Dev: IDevice; Name: string; Filter: dword = D3DX_FILTER_NONE; Colorkey: dword = 0; Format: TD3DFormat = 0): ITexture;
function LoadTextureFromFile(Dev: IDevice; Name: string; Filter: dword = D3DX_FILTER_NONE; Colorkey: dword = 0; Format: TD3DFormat = 0): ITexture;
function LoadBMP(Name: string): TBitMaP;
function BMPFromTex(Tex: ITexture): TBitmap;
function BMPFromSurf(Surf: ISurf): TBitmap;
function TexFromBMP(Bmp: TBitmap; Ckey: TD3DColor = 0): ITexture;
procedure QuitGame;
function ShowMsg(Txt,Caption:string;Data:string='';LCenter:boolean=false):boolean;overload;
function ShowMsg(Lines:TStrings;Caption:string;Data:string='';LCenter:boolean=false):boolean;overload;
function GetStrings(entry:string):TStringList;
procedure DrawSplash;

var
  GameDev: IDevice;
  GameWin: TWinControl;
  GameServer:TObject;

  RootDir:string;
  
implementation

uses D3DClass,Wins,GUI;

////////////////////////// FUNCTIONS

function LoadFile(Name: string): TLoadFile;
var
  MS: TMS;
  ext: string;
begin
  MS := TMS.Create;

  ext := ExtractFileExt(Name);


  if CompStr(Ext, '.wav') then Name := RootDir + 'Data\Sound\' + Name;
  if CompStrArray(Ext, ['.jpg', '.png', '.bmp']) then Name := RootDir + 'Data\Graphic\' + Name;
  if CompStrArray(Ext, ['.mid', '.mp3', '.wma']) then Name := RootDir + 'Data\Music\' + Name;


  if not FileExists(Name)then
  begin
  MsgBox(Format('File Not Found : %s',[Name]));
  Exit;
  end;
  MS.LoadFromFile(Name);



  Result.Name := Name;
  Result.Size := MS.Size;
  Getmem(Result.Bytes, MS.Size);
  Move(MS.Memory^, Result.Bytes^, MS.Size);

  MS.Free;
end;

procedure FreeFile(F: TLoadFile);
begin
  FreeMem(F.Bytes);
  F.Bytes := nil;
  F.Size := 0;
end;

function LoadTexture(Dev: IDevice; Name: string; Filter: dword; Colorkey: dword; Format: TD3DFormat): ITexture;
var
  T: ITexture;
begin
    if FileExists(RootDir + 'Data\Graphic\' + Name) then
      T := LoadTextureFromFile(Dev, RootDir + 'Data\Graphic\' + Name, Filter, Colorkey, Format);

  Result := T;

end;

function LoadTextureFromFile(Dev: IDevice; Name: string; Filter: dword; Colorkey: dword; Format: TD3DFormat): ITexture;
begin
  Result := nil;
  if Failed(D3DXCreateTextureFromFileEx(Dev,
    PChar(Name), 0, 0,
    1, 0,D3DFMT_A8R8G8B8,D3DPOOL_MANAGED, Filter, D3DX_FILTER_NONE, ColorKey,
    nil, nil, Result)) then ShowError(ERR_TEXLOAD);


end;


function LoadBMP(Name: string): TBitmap;
var
  BMP: TBitmap;


  procedure LoadFromFile;
  begin
    BMP.LoadFromFile(RootDir + 'Data\Graphic\' + Name);
  end;

begin
  BMP := TBitmap.Create;
    if FileExists(RootDir + 'Data\Graphic\' + Name) then
      LoadFromFile;


  Result := BMP;
end;



function BMPFromTex(Tex: ITexture): TBitmap;
var
  BMPtx: TDIB;
  desc: TD3DSurface_Desc;
  LR: TD3DLocked_Rect;

begin

  if Tex = nil then ShowError(ERR_TEXCONV);
  TeX.GetLevelDesc(0, desc);

  case desc.Format of
    D3DFMT_A8R8G8B8, D3DFMT_X8R8G8B8: ;
  else
    begin ShowError(ERR_NOT32BITTEX);
    end;
  end;

  BMPtx := TDIB.Create;
  BMPtx.SetSize(desc.Width, desc.height, 32);
  TeX.LockRect(0, LR, nil, 0);
  System.Move(LR.pBits^, BMPtx.pBits^, desc.width * desc.height * 4);
  TeX.UnlockRect(0);
  BmpTX.Mirror(false, true);
  Bmptx.BitCount := 24;

  Result := TBitmap.Create;
  with Result do
  begin
    Width := BmpTx.Width;
    Height := BmpTx.height;
    PixelFormat := pf24Bit;
    Canvas.Draw(0, 0, BmpTX);
  end;
  BmpTx.Free;
end;

function BMPFromSurf(Surf: ISurf): TBitmap;
var
  BMPtx: TDIB;
  desc: TD3DSurface_Desc;
  LR: TD3DLocked_Rect;
  sf:isurf;
begin

  if Surf = nil then ShowError(ERR_TEXCONV);

  Surf.GetDesc( desc);

  case desc.Format of
    D3DFMT_A8R8G8B8, D3DFMT_X8R8G8B8: ;
  else
    begin ShowError(ERR_NOT32BITTEX);
    end;
  end;

  BMPtx := TDIB.Create;
  BMPtx.SetSize(desc.Width, desc.height, 32);
  gamedev.CreateImageSurface(desc.Width,desc.Height,desc.Format,sf);

  gamedev.CopyRects(surf,nil,0,sf,nil);

  Sf.LockRect( LR, nil, 0);

 // Surf.
  if lr.pitch=0 then msgbox('je tu cosi shnileho');
  System.Move(LR.pBits^, BMPtx.pBits^, desc.width * desc.height * 4);
  Sf.UnlockRect;

  BmpTX.Mirror(false, true);
  Bmptx.BitCount := 24;

  Result := TBitmap.Create;
  with Result do
  begin
    Width := BmpTx.Width;
    Height := BmpTx.height;
    PixelFormat := pf24Bit;
    Canvas.Draw(0, 0, BmpTX);
  end;
  BmpTx.Free;
end;



function TexFromBMP(Bmp: TBitmap; Ckey: TD3DColor): ITexture;
var
  MS: TMS;
begin
  MS := TMS.Create;
  Bmp.PixelFormat := pf24bit;
  Bmp.SaveToStream(MS);
  if Failed(D3DXCreateTextureFromFileInMemoryEx(GameDev, MS.Memory, MS.Size, 0, 0, 1, 0, 0, D3DPOOL_MANAGED, 1, 1, ckey, nil, nil, Result))
    then ShowError(ERR_TEXCONV);
  MS.Free;
end;


procedure QuitGame;
 begin
  TForm(GameWin).Close;

 end;


function ShowMsg(Txt,Caption:string;Data:string;LCenter:boolean):boolean;
var List:TStringList;
begin
 List:=TStringList.Create;
 List.Add(txt);
 Result:=Showmsg(List,Caption,Data,LCenter);

 List.Free;
end;

function ShowMsg(Lines:TStrings;Caption:string;Data:string;LCenter:boolean):boolean;
var Obj:TGuiObj;
begin
with UsedWins do
begin
 Result:=false;
 Obj:=MsgWin.Find('Msglabel');
 Obj.AddCaption(Caption,Fonts[FN_MSGLAB],Point(0, 0));

 Obj:=MsgWin.Find('Text_Msg');
 Obj.AddStrings(Lines,Fonts[FN_MSG],LCenter);
// MsgWin.Center(true,true);
 WinMgr.ShowModal(MsgWin,MsgWin.Find('BTN_MsgOK'),Data);
 MsgWin.ToFront;
end;

end;

function GetStrings(entry:string):TStringList;
begin
 Result:=nil;
 if TextList.Items.Find(entry)=nil then
  begin
  if CampText.Items.Find(entry)=nil then
   ShowError(ERR_TEXTENTRY)else
     Result:=CampText.Items.Find(entry).Text.Lines;

  end
  else
 Result:=TextList.Items.Find(entry).Text.Lines;
end;


procedure DrawSplash;
var Bmp:TBitmap;
    C:TCanvas;
begin
  Bmp:=TBitmap.Create;
  Bmp.LoadFromFile(RootDir+'Data\Graphic\Screens\Splash.bmp');
  C:=TCanvas.Create;
  C.Handle:=GetDc(0);
  C.Draw((Screen.DesktopWidth-Bmp.Width)div 2,
  (Screen.DesktopHeight-Bmp.Height)div 2,Bmp);
  C.Free;
  Bmp.Free;
end;


initialization
RootDir := Exedir;

end.

