{
  Drake Rider

  (C) 2002 Vampyre SoftWorks
  Created by :  Marek Mauder  
}	


unit Music;

interface

uses Windows, Classes, SysUtils, gameTypes, WinFunc, MIDPlay,
  VTextList, MainGame;


type

  TMusicMgr = class

  public
    List: TStringList;
    IMID: TMIDPlay;

    constructor Create;
    destructor Destroy; override;

    procedure PlayFile(Name: string);
    procedure StartPList(Def: boolean = true; L: TStringList = nil);

    procedure SetVol(vol: long);



  end;


var
  MusMgr: TMusicMgr;

implementation



constructor TMusicMgr.Create;
var
  i: long;
  SR: TSearchRec;
begin
  inherited;
  IMid := TMIDPlay.Create(GameWin);
  IMid.Init;

  List := TStringList.Create;
  if FindFirst(Exedir + 'Data\Music\*.mid', faAnyFile, SR) = 0 then
  begin
    List.Add(SR.name);
    while FindNext(SR) = 0 do
      List.Add(SR.name);

   FindClose(Sr);
  end;
  List.SaveToFile(Exedir + 'Data\Music\generated.ply');

  for i := 0 to List.Count - 1 do
    List[i] := ExeDir + 'Data\Music\' + List[i];

end;

destructor TMusicMgr.Destroy;
begin
  IMid.PlayList.Restart;
  IMid.StopAll;
  List.Free;
  IMid.Free;
  inherited;
end;

procedure TMusicMgr.PlayFile(Name: string);
var
  L: TStringList;
begin
  L := TStringList.Create;
  L.Add(Rootdir + 'Data\Music\' + Name);
  if not FileExists(L[0])then Exit;
  IMID.StopAll;
  IMID.PlayList.Options := [poShuffle,poContinuous];
  IMID.PlayList.LoadFromFiles(L, true);
  L.Free;
end;

procedure TMusicMgr.StartPList(Def: boolean; L: TStringList);
begin
  IMID.StopAll;
  IMID.PlayList.Options := [poShuffle, poContinuous];
  if Def then L := List;
  IMID.PlayList.LoadFromFiles(L, true);

end;

procedure TMusicMgr.SetVol(vol: long);
var
  inDB: long;
begin
  case vol of
    1: inDB := -100;
    2: inDB := -10;
    3: inDB := -5;
    4: inDB := 0;
    5: inDB := 5;
  end;
  IMID.Volume := inDB;
end;

end.
