{
  Drake Rider

  (C) 2002 Vampyre SoftWorks
  Created by :  Marek Mauder  
}	


unit Objects;

interface

uses Windows, Classes, SysUtils, DXStuff,EngineObj,
   gameTypes, WinFunc, ContNRS, MainGame, DXObj;

type

  TObjMgr = class
  public
    Objects: TBaseInfoList;

    constructor Create;
    destructor Destroy; override;
    procedure Load;
    procedure Save;
    function Add(Obj: TBaseInfo): TBaseInfo;
    function Find(name: string): TBaseInfo;


  end;


type

  TObj_HDR = record
    ID: TChar4;
    Sp1: Dword;
    Info: TChar20;
    VerHIWORD: word;
    VerLOWORD: word;
    Size: dword;
    Sp2: Dword;
  end;




const

  Obj_EXT = '.drd';
  Obj_ID = 'DROB';
  Obj_Info='DRAKE RIDER OBJECTS ';
  
  Obj_HDR: TObj_Hdr = (ID: Obj_ID;
    Sp1: Byte('@') or (5 shl 8) or (5 shl 16) or (Byte('@') shl 24);
    Info: Obj_Info; VERHIWORD: VerHi; VERLOWORD: VerLo; Size: 0;
    Sp2: Byte('@') or (5 shl 8) or (5 shl 16) or (Byte('@') shl 24)

    );

var
  ObjMgr: TObjMgr;


implementation


constructor TObjMgr.Create;
begin
 inherited;
 Objects:=TBaseInfoList.Create;

end;

destructor TObjMgr.Destroy;
begin

 Objects.Free;
 inherited;
end;


procedure TObjMgr.Load;
var hd:TObj_Hdr;
    cl:string;
    O:TBaseInfo;
    i,cnt:long;
begin
Objects.Clear;
_MS.Clear;
_MS.LoadFromFile(RootDir + FL_OBJS);
_MS.ReadBuffer(hd,sizeof(hd));
_MS.ReadBuffer(cnt,sizeof(cnt));
for i:=0 to cnt-1 do
 begin
  cl:=ReadStr(_MS);

  O:=TEngObjInfo(FindClass(cl)).Create;
  O.Load(_MS);
  Objects.Add(O);
 end;

_MS.Clear;

end;


procedure TObjMgr.Save;
var
  i: long;
begin
  _MS.Clear;
  _MS.WriteBuffer(Obj_Hdr, SizeOf(Obj_Hdr));
  _MS.WriteBuffer(Objects.Count, SizeOf(Objects.Count));
  for i := 0 to Objects.Count - 1 do
    begin
    WriteStr(_MS,Objects[i].Classname);
       Objects[i].Save(_MS);

    end;

  _MS.SaveToFile(RootDir + FL_OBJS);

end;


function TObjMgr.Add(Obj: TBaseInfo): TBaseInfo;
var i:long;
begin
  for i:=0 to Objects.Count-1 do
  if CompStr(Objects[i].Name,Obj.Name)then
   begin
    MsgBox('Object of same name already exists!!Rename it!!');
    Exit;
   end;

  Objects.Add(Obj);
  Result := Obj;

end;


function TObjMgr.Find(Name: string): TBaseInfo;
var i:long;
begin
 Result:=nil;
 for i:=0 to Objects.Count-1  do
  if CompStr(Name,Objects[i].Name) then
   Result:=Objects[i];


end;




end.

