{
  Drake Rider

  (C) 2002 Vampyre SoftWorks
  Created by :  Marek Mauder  
}	


unit Wins;

interface

uses
  Windows, SysUtils, Classes, DXObj, GUI,
  WinFunc, gameTypes, Maingame, DXStuff;


type

  TUsedWins = record
    Splash,
      MainMenu,
      AniWin,
      Optionsmain,
      OptGFX,
      OptSFX,
      OptMus,
      OptGame,
      OptIn,
      MsgWin,
      Credits,
      NewGame,
      NGselmode,
      StoryWin,
      InterGame,
      EndWin,
      InputWin,
      PlayersWin,
      IngMenu

    : TGuiWin;


      StoryBox,
      IEdit,
      scCredits,
      imCredits,
      PlImg

      :TGuiObj;


  end;


var
  NullP: TPoint = (X: 0; Y: 0);
  WinMgr: TGuiController;



procedure BuildWins(Mgr: TGuiController);


var
  UsedWins: TUsedWins;

implementation

procedure BuildWins(Mgr: TGuiController);
var
  Win: TGuiWin;
  Obj: TGuiObj;
  MedBtn,
    SmallBtn,
    BigBtn: TGuiObj;
  TX: TDXTexture;
  List:TStringList;

const
  MB_left = 320 + (320 - 192) div 2;
  MBbig_left=390+(390-192)div 2;
  R_TextSQ:TRect=(Left:320+20;Top:100;Right:280;Bottom:290);
  R_TextMsg:TRect=(Left:15;Top:70;Right:482;Bottom:290);
  R_TextBig:TRect=(Left:30;Top:30;Right:330;Bottom:520);
  R_TextStory:TRect=(Left:50;Top:20;Right:680;Bottom:500);


begin
  List:=TStringList.Create;


  ////////////////////  SPLASH WIN /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'Splash', Rect((800 - 512) div 2, (600 - 128) div 2, 512, 128), $BDFFEEEE,TexMgr.GetTex('screens\splash.bmp'));
  Win.SetColors($FFFFFFFF, $FFFFFFFF, $FFFFFFFF);
  UsedWins.Splash := Win;
  Mgr.Add(Win);
  Win := nil;
  ////////////////////////////////////////

  //////////  ANI PLAY WIN /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'AniWin', Rect(80, 60, 640, 480), $FFFFFFFF, TexMgr.GetTex('anim\anilog1.jpg'));
  Win.Blend := bl_add;

  Mgr.Add(Win);
  UsedWins.AniWin := Win;
  Win := nil;
  ////////////////////////////////////////////


  //////////  MAIN MENU /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'MainMenu', Rect(80, 60, 640, 480), $DDFFDDDD, TexMgr.GetTex('screens\menu.jpg'));
  Obj := TGuiObj.Create(Mgr.Device, 'MM_Label', Rect(320 + 32, 20, 256, 128), $FFFFFFFF, TexMgr.GetTex('gui\drake_logo.png'));
  Obj.Blend := bl_add;
  Obj.CanAct := false;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_Newgame', Rect(MB_Left, 140, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Nov Hra', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_Loadgame', Rect(MB_Left, 140 + 48 + 12, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Obnovit Hru', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_Options', Rect(MB_Left, 140 + 60 + 60, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Nastaven', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_Credits', Rect(MB_Left, 140 + 180, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Credits', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_Exit', Rect(MB_Left, 140 + 180 + 60, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Konec', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.MainMenu := Win;
  Win := nil;
  ////////////////////////////////////////////////////




  //////////  OPTIONS MAIN /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'OptionsMain', Rect(80, 60, 640, 480), $0, TexMgr.GetTex('screens\options.jpg'));

  Obj := TGuiObj.Create(Mgr.Device, 'OptmainLabel', Rect(320 + 32, 30, 256, 64), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Nastaven', Fonts[FN_SCRLABEL], Point(0, 0));
  Obj.CanAct := false;
  Obj.Blend := bl_add;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_GfxOpt', Rect(MB_Left, 120, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Grafika', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_SfxOpt', Rect(MB_Left, 120 + 58, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Zvuk', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_MusOpt', Rect(MB_Left, 120 + 58 * 2, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Hudba', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_GameOpt', Rect(MB_Left, 120 + 58 * 3, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Hern Volby', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_InOpt', Rect(MB_Left, 120 + 58 * 4, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Ovldn', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_OptmainBack', Rect(MB_Left, 120 + 58 * 5, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Zpt', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.OptionsMain := Win;
  Win := nil;
  ////////////////////////////////////////////////////


  //////////  OPTIONS GFX /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'OptGfx', Rect(80, 60, 640, 480), $0, TexMgr.GetTex('screens\options.jpg'));

  Obj := TGuiObj.Create(Mgr.Device, 'OptGfxLabel', Rect(320 + 32, 30, 256, 64), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Grafika', Fonts[FN_SCRLABEL], Point(0, 0));
  Obj.CanAct := false;
  Obj.Blend := bl_add;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'LAB_Res', Rect(MB_Left, 100, 192, 40), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('800x600x32', Fonts[FN_SMBTN_L], Point(0, 0));
  Obj.CanAct := false;
  Obj.Blend := bl_add;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_res640x16', Rect(320 + 20, 150, 140, 40), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('640x480x16', Fonts[FN_SMBTN_L], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_res640x32', Rect(320 + 20 + 140, 150, 140, 40), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('640x480x32', Fonts[FN_SMBTN_L], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_res800x16', Rect(320 + 20, 150 + 40, 140, 40), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('800x600x16', Fonts[FN_SMBTN_L], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_res800x32', Rect(320 + 20 + 140, 150 + 40, 140, 40), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('800x600x32', Fonts[FN_SMBTN_L], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_res1024x16', Rect(320 + 20, 150 + 80, 140, 40), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('1024x768x16', Fonts[FN_SMBTN_L], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_res1024x32', Rect(320 + 20 + 140, 150 + 80, 140, 40), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('1024x768x32', Fonts[FN_SMBTN_L], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_fullscr', Rect(320 + 20, 150 + 80 + 20 + 40, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Cel Obrazovka', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'CB_fullscr', Rect(320 + 20 + 192 + 20 + 20 + 4 + 4, 150 + 80 + 20 + 40 + 4 + 4, 32, 32), 0, TexMgr.GetTex('gui\CB_false.jpg'));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_OptGFXBack', Rect(MB_Left, 410, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Zpt', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.OptGFX := Win;
  Win := nil;
  ////////////////////////////////////////////////////


  //////////  OPTIONS SFX /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'OptSfx', Rect(80, 60, 640, 480), $0, TexMgr.GetTex('screens\options.jpg'));

  Obj := TGuiObj.Create(Mgr.Device, 'OptSfxLabel', Rect(320 + 32, 30, 256, 64), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Zvuk', Fonts[FN_SCRLABEL], Point(0, 0));
  Obj.CanAct := false;
  Obj.Blend := bl_add;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'lab_turnsfx', Rect(320 + 20, 100, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Zvuk zapnut', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'CB_turnsfx', Rect(320 + 20 + 192 + 20 + 20 + 4 + 4, 100 + 8, 32, 32), 0, TexMgr.GetTex('gui\CB_false.jpg'));
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'lab_svolume', Rect(320 + 64, 150, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Hlasitost', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'TB_svol_1', Rect(320 + 35, 190, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'TB_svol_2', Rect(320 + 35 + 50, 190, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'TB_svol_3', Rect(320 + 35 + 100, 190, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'TB_svol_4', Rect(320 + 35 + 150, 190, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'TB_svol_5', Rect(320 + 35 + 200, 190, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_OptSFXBack', Rect(MB_Left, 410, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Zpt', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.OptSFX := Win;
  Win := nil;
  ////////////////////////////////////////////////////


  //////////  OPTIONS MUS /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'OptMUS', Rect(80, 60, 640, 480), $0, TexMgr.GetTex('screens\options.jpg'));

  Obj := TGuiObj.Create(Mgr.Device, 'OptMUSLabel', Rect(320 + 32, 30, 256, 64), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Hudba', Fonts[FN_SCRLABEL], Point(0, 0));
  Obj.CanAct := false;
  Obj.Blend := bl_add;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'lab_turnmus', Rect(320 + 20, 100, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Hudba zapnuta', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'CB_turnmus', Rect(320 + 20 + 192 + 20 + 20 + 4 + 4, 100 + 8, 32, 32), 0, TexMgr.GetTex('gui\CB_false.jpg'));
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'lab_volume', Rect(320 + 64, 150, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Hlasitost', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'TB_vol_1', Rect(320 + 35, 190, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'TB_vol_2', Rect(320 + 35 + 50, 190, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'TB_vol_3', Rect(320 + 35 + 100, 190, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'TB_vol_4', Rect(320 + 35 + 150, 190, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'TB_vol_5', Rect(320 + 35 + 200, 190, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'lab_randomply', Rect(320 + 30, 240, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Nhodn poad', Fonts[FN_MEDBTN], Point(0, 0), true);
  Obj.CanAct := false;
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'CB_randply', Rect(320 + 20 + 192 + 20 + 20 + 4 + 4, 240 + 8, 32, 32), 0, TexMgr.GetTex('gui\CB_false.jpg'));
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_OptMUSBack', Rect(MB_Left, 410, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Zpt', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.OptMus := Win;
  Win := nil;
  ////////////////////////////////////////////////////

  //////////  OPTIONS GamePlay /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'OptGame', Rect(80, 60, 640, 480), $0, TexMgr.GetTex('screens\options.jpg'));

  Obj := TGuiObj.Create(Mgr.Device, 'OptGameLabel', Rect(320 + 12, 30, 296, 69), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Hern volby', Fonts[FN_SCRLABEL], Point(0, 0));
  Obj.CanAct := false;
  Obj.Blend := bl_add;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'lab_speed', Rect(320 + 64, 80, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Rychlost Hry', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'TB_gs_1', Rect(320 + 35, 120, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'TB_gs_2', Rect(320 + 35 + 50, 120, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'TB_gs_3', Rect(320 + 35 + 100, 120, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'TB_gs_4', Rect(320 + 35 + 150, 120, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'TB_gs_5', Rect(320 + 35 + 200, 120, 50, 30), 0, TexMgr.GetTex('gui\tb_false.jpg'));
  Obj.SetColors($AAEEEEEE, $FFEEEEEE, $FFFFFFFF);
  Win.Add(Obj);

  {List.Add('Not Implemented Yet');
  List.Add('Under Construction');

  Obj := TGuiObj.Create(Mgr.Device, 'text_gnotyet', R_textsq, $FFFFFFFF, TexMgr.GetTex('gui\text_sq.png'));
  Obj.CanAct:=false;
  Obj.AddStrings(List,Fonts[FN_txtwin],true,true);
  Win.Add(Obj);
   }


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_OptGameBack', Rect(MB_Left, 410, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Zpt', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.OptGame := Win;
  Win := nil;
  ////////////////////////////////////////////////////


  //////////  OPTIONS Input /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'OptIn', Rect(80, 60, 640, 480), $0, TexMgr.GetTex('screens\options.jpg'));

  Obj := TGuiObj.Create(Mgr.Device, 'OptInLabel', Rect(320 + 22, 30, 276, 69), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Ovldn', Fonts[FN_SCRLABEL], Point(0, 0));
  Obj.CanAct := false;
  Obj.Blend := bl_add;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'lab_actpl', Rect(320+(320-220)div 2, 100, 220, 48),$FFFFFF99, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Hr 1', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct:=false;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'btn_plprev', Rect(320+(320-212)div 2-40, 100 + 8, 32, 32), 0, TexMgr.GetTex('gui\btn_left.jpg'));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'btn_plnext', Rect(320+(320-212)div 2+212+8, 100 + 8, 32, 32), 0, TexMgr.GetTex('gui\btn_right.jpg'));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_iup', Rect(320+30 ,160, 120, 32), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Nahoru', Fonts[FN_SMBTN_L], Point(0, 0));
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'lab_iup', Rect(320+30+120+10 ,160+32*0, 140, 32), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('up arrow', Fonts[FN_SMBTN_L], Point(0, 0));
  Obj.CanAct:=false;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_idown', Rect(320+30 ,160+32*1, 120, 32), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Dol', Fonts[FN_SMBTN_L], Point(0, 0));
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'lab_idown', Rect(320+30+120+10 ,160+32*1, 140, 32), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('down arrow', Fonts[FN_SMBTN_L], Point(0, 0));
  Obj.CanAct:=false;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_ileft', Rect(320+30 ,160+32*2, 120, 32), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Doleva', Fonts[FN_SMBTN_L], Point(0, 0));
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'lab_ileft', Rect(320+30+120+10 ,160+32*2, 140, 32), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('left arrow', Fonts[FN_SMBTN_L], Point(0, 0));
  Obj.CanAct:=false;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_iright', Rect(320+30 ,160+32*3, 120, 32), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Doprava', Fonts[FN_SMBTN_L], Point(0, 0));
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'lab_iright', Rect(320+30+120+10 ,160+32*3, 140, 32), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('right arrow', Fonts[FN_SMBTN_L], Point(0, 0));
  Obj.CanAct:=false;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_ifire1', Rect(320+30 ,160+32*4, 120, 32), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Stela Jezd.', Fonts[FN_SMBTN_L], Point(0, 0));
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'lab_ifire1', Rect(320+30+120+10 ,160+32*4, 140, 32), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('ctrl', Fonts[FN_SMBTN_L], Point(0, 0));
  Obj.CanAct:=false;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_ifire2', Rect(320+30 ,160+32*5, 120, 32), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Stela Drk.', Fonts[FN_SMBTN_L], Point(0, 0));
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'lab_ifire2', Rect(320+30+120+10 ,160+32*5, 140, 32), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('shift', Fonts[FN_SMBTN_L], Point(0, 0));
  Obj.CanAct:=false;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_OptInBack', Rect(MB_Left, 410, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Zpt', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.OptIn := Win;
  Win := nil;
  ////////////////////////////////////////////////////

  //////////  MESSAGE WINDOW/////////////////
  Win := TGuiWin.Create(Mgr.Device, 'MsgWin', Rect((800-512)div 2,(600-384)div 2,512,384), $0, TexMgr.GetTex('gui\msgwin.jpg'));

  Obj := TGuiObj.Create(Mgr.Device, 'MsgLabel', Rect(66, 0, 380,40), 0, TexMgr.GetTex('gui\btn_transmsg.png'));
  Obj.AddCaption('Message', Fonts[FN_MSGLAB], Point(0, 0));
  Obj.CanAct := false;
  Obj.Blend := bl_add;
  Win.Add(Obj);

  List.Clear;
  List.Add('Default Message');
  List.Add('What Message     - Default');
  List.Add('What Default     - Message');

  Obj := TGuiObj.Create(Mgr.Device, 'text_msg', R_textmsg, $FFFFFFFF, TexMgr.GetTex('gui\text_msg.png'));
  Obj.CanAct:=false;
  Obj.AddStrings(List,Fonts[FN_Msg]);
  Win.Add(Obj);



  Obj := TGuiObj.Create(Mgr.Device, 'BTN_MsgOK', Rect((512-140)div 2, 384-40-15, 140, 40), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('OK', Fonts[FN_SMBTN_L], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.MsgWin := Win;
  Win := nil;
  ////////////////////////////////////////////////////


  //////////  Credits /////////////////
{  Win := TGuiWin.Create(Mgr.Device, 'Credits', Rect(80, 60, 640, 480), $0, TexMgr.GetTex('screens\menu.jpg'));

  //Obj := TGuiObj.Create(Mgr.Device, 'OptInLabel', Rect(320 + 22, 30, 276, 69), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj := TGuiObj.Create(Mgr.Device, 'cr_Label', Rect(320 + 32, 20, 256, 128), $FFFFFFFF, TexMgr.GetTex('gui\drake_logo.png'));
  Obj.Blend := bl_add;
  Obj.CanAct := false;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'text_credits', R_textsq, $FFFFFFFF, TexMgr.GetTex('gui\text_sq.png'));
  Obj.CanAct:=false;
  Obj.AddStrings(GetStrings('credits'),Fonts[FN_txtwin],true,true);
  Win.Add(Obj);




  Obj := TGuiObj.Create(Mgr.Device, 'BTN_CreditsBack', Rect(MB_Left, 410, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Zpt', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.Credits := Win;
  Win := nil;      }

   Win := TGuiWin.Create(Mgr.Device, 'Credits', Rect(10, 10, 780, 580), $0, TexMgr.GetTex('screens\newgame.jpg'));

  //Obj := TGuiObj.Create(Mgr.Device, 'OptInLabel', Rect(320 + 22, 30, 276, 69), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj := TGuiObj.Create(Mgr.Device, 'cr_Label', Rect(390+67, 0, 256, 128), $FFFFFFFF, TexMgr.GetTex('gui\drake_logo.png'));
  Obj.Blend := bl_add;
  Obj.CanAct := false;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'text_credits',rect(390+20,100,350,370), $FFFFFFFF, TexMgr.GetTex('gui\text_sq.png'));
  Obj.CanAct:=false;
  Obj.AddStrings(GetStrings('credits'),Fonts[FN_txtwin],true,true);
  Obj.Blend:=bl_add;
  Win.Add(Obj);
  UsedWins.scCredits := Obj;

  Obj := TGuiObj.Create(Mgr.Device, 'img_credits',R_textbig, $FFFFFFFF, TexMgr.GetTex('gui\text_sq.png'));
  Obj.CanAct:=false;
  Win.Add(Obj);
  UsedWins.imCredits := Obj;
  
  Obj := TGuiObj.Create(Mgr.Device, 'BTN_CreditsBack', Rect(MBbig_Left, 510, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Zpt', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.Credits := Win;
  Win := nil;

  ////////////////////////////////////////////////////



  //////////  NEWGAME /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'NewGame', Rect(10, 10,780 ,580), $0, TexMgr.GetTex('screens\newgame.jpg'));

  {Obj := TGuiObj.Create(Mgr.Device, 'lab_pl1', Rect(390 + 20, 180, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Hr 1', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'CB_pl1', Rect(390 + 20 + 192 + 20 + 20 + 4 + 4, 180 + 8, 32, 32), 0, TexMgr.GetTex('gui\CB_false.jpg'));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'lab_pl2', Rect(390 + 20, 240, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Hr 2', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'CB_pl2', Rect(390 + 20 + 192 + 20 + 20 + 4 + 4, 240 + 8, 32, 32), 0, TexMgr.GetTex('gui\CB_false.jpg'));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'lab_pl3', Rect(390 + 20, 300, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Hr 3', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'CB_pl3', Rect(390 + 20 + 192 + 20 + 20 + 4 + 4, 300 + 8, 32, 32), 0, TexMgr.GetTex('gui\CB_false.jpg'));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'lab_pl4', Rect(390 + 20, 360, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Hr 4', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'CB_pl4', Rect(390 + 20 + 192 + 20 + 20 + 4 + 4, 360 + 8, 32, 32), 0, TexMgr.GetTex('gui\CB_false.jpg'));
  Win.Add(Obj);

   }
  Obj := TGuiObj.Create(Mgr.Device, 'text_ng', R_textbig, $FFFFFFFF, TexMgr.GetTex('gui\text_big.png'));
  Obj.CanAct:=false;
  Obj.AddStrings(GetStrings('ng2'),Fonts[FN_txtwin],true,true);
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_NewGo', Rect(MBbig_Left, 440, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Start', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_NewBack', Rect(MBbig_Left, 510, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Zpt', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.NewGame := Win;
  Win := nil;
  ////////////////////////////////////////////////////


  //////////  NGSelMode /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'NGSELMODE', Rect(80, 60, 640, 480), $0, TexMgr.GetTex('screens\menu.jpg'));

  Obj := TGuiObj.Create(Mgr.Device, 'ngLabel', Rect(320 + 32, 30, 256, 64), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Nov Hra', Fonts[FN_SCRLABEL], Point(0, 0));
  Obj.CanAct := false;
  Obj.Blend := bl_add;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_camp', Rect(MB_Left, 120, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Kampa', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_NGselmodeBack', Rect(MB_Left, 410, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Zpt', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.NGSelmode := Win;
  Win := nil;
  ////////////////////////////////////////////////////


  //////////  Story /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'Story', Rect(10, 10, 780, 580), $0, TexMgr.GetTex('screens\story.jpg'));

  Obj := TGuiObj.Create(Mgr.Device, 'text_story', R_textstory, $FFFFFFFF, TexMgr.GetTex('gui\text_story.png'));
  Obj.CanAct:=false;
  Obj.AddStrings(GetStrings('MainStory'),Fonts[FN_story],true,true);
  Win.Add(Obj);
  UsedWins.StoryBox:=Obj;

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_StoryBack', Rect((780-192)div 2, 520, 192, 46), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('OK', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.Storywin := Win;
  Win := nil;
  ////////////////////////////////////////////////////


  //////////  INTERGAME /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'InterGame', Rect(10, 10,780 ,580), $0, TexMgr.GetTex('screens\newgame.jpg'));

  Obj := TGuiObj.Create(Mgr.Device, 'lab_pl1', Rect(390 + 20, 290, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Hr 1', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'CB_pl1', Rect(390 + 20 + 192 + 20 + 20 + 4 + 4, 290 + 8, 32, 32), 0, TexMgr.GetTex('gui\CB_false.jpg'));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'lab_pl2', Rect(390 + 20, 340, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Hr 2', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'CB_pl2', Rect(390 + 20 + 192 + 20 + 20 + 4 + 4, 340 + 8, 32, 32), 0, TexMgr.GetTex('gui\CB_false.jpg'));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'lab_pl3', Rect(390 + 20, 390, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Hr 3', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'CB_pl3', Rect(390 + 20 + 192 + 20 + 20 + 4 + 4, 390 + 8, 32, 32), 0, TexMgr.GetTex('gui\CB_false.jpg'));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'lab_pl4', Rect(390 + 20, 440, 192, 48), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Hr 4', Fonts[FN_MEDBTN], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);
  Obj := TGuiObj.Create(Mgr.Device, 'CB_pl4', Rect(390 + 20 + 192 + 20 + 20 + 4 + 4, 440 + 8, 32, 32), 0, TexMgr.GetTex('gui\CB_false.jpg'));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'text_inter', R_textbig, $FFFFFFFF, TexMgr.GetTex('gui\text_big.png'));
  Obj.CanAct:=false;
  Obj.AddStrings(GetStrings('ng2'),Fonts[FN_txtwin],true,true);
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_IPlayers', Rect(MBbig_Left,50, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Hri', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_ISave', Rect(MBbig_Left, 110, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Uloit', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_IOpt', Rect(MBbig_Left, 170, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Nastaven', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_IBack', Rect(MBbig_Left, 230, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Konec', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_IDetails', Rect(MBbig_Left-390, 510, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Podrobnosti', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_InterGo', Rect(MBbig_Left, 510, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Start', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);




  Mgr.Add(Win);
  UsedWins.InterGame := Win;
  Win := nil;
  ////////////////////////////////////////////////////


  //////////  ENDGAME /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'ENDGAME', Rect(80, 60, 640, 480), $0, TexMgr.GetTex('screens\endgame.jpg'));

  Obj := TGuiObj.Create(Mgr.Device, 'egLabel', Rect(320 + 32, 30, 256, 64), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Konec', Fonts[FN_SCRLABEL], Point(0, 0));
  Obj.CanAct := false;
  Obj.Blend := bl_add;
  Win.Add(Obj);

 { Obj := TGuiObj.Create(Mgr.Device, 'BTN_camp', Rect(MB_Left, 120, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Kampa', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_user', Rect(MB_Left, 120 + 58, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Vlastn Mapy', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);
  }

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_EGBack', Rect(MB_Left, 410, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Hlavn Menu', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.EndWin := Win;
  Win := nil;
  ////////////////////////////////////////////////////


  //////////  INPUT WINDOW/////////////////
  Win := TGuiWin.Create(Mgr.Device, 'InpWin', Rect(200-56,(600-256)div 2,512,216), $0, TexMgr.GetTex('gui\iwin.jpg'));

  Obj := TGuiObj.Create(Mgr.Device, 'ILabel', Rect(66, 5, 380,40), 0, TexMgr.GetTex('gui\btn_transmsg.png'));
  Obj.AddCaption('Message', Fonts[FN_MSGLAB], Point(0, 0));
  Obj.CanAct := false;
  Obj.Blend := bl_add;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'Lab_IEdit', Rect((512-384)div 2, 256-60-40-15-50, 384,64), $FFFFFFFF, TexMgr.GetTex('gui\btn_transmsg.png'));
  Obj.AddCaption('Edit1', Fonts[FN_Story], Point(0, 0));
  Obj.CanAct:=false;
  Win.Add(Obj);
  UsedWins.IEdit:=Obj;

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_IOK', Rect((512-140)div 2, 256-40-15-40, 140, 40), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('OK', Fonts[FN_SMBTN_L], Point(0, 0));
  Win.Add(Obj);

  Mgr.Add(Win);
  UsedWins.InputWin := Win;
  Win := nil;
  ////////////////////////////////////////////////////


  //////////  PLAYERS WIN /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'Players', Rect(10, 10, 780, 580), $0, TexMgr.GetTex('screens\story.jpg'));

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_PlsBack', Rect((780-192)div 2, 520, 192, 46), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('OK', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'LAb_PlName', Rect((780-512)div 2, 20, 512,64), $FFFFFFFF, TexMgr.GetTex('gui\btn_plname.png'));
  Obj.AddCaption('Moniiinka [Hr 1]', Fonts[FN_SMBTN_L], Point(0, 0));
  Obj.Blend:=bl_add;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_Plsprev', Rect((780-512)div 2-40, 20+16, 32, 32), 0, TexMgr.GetTex('gui\btn_left.jpg'));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_Plsnext', Rect((780-512)div 2+512+8, 20+16, 32, 32), 0, TexMgr.GetTex('gui\btn_right.jpg'));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'Lab_XP', Rect(50,90, 512,64), $FFFFFFAA, TexMgr.GetTex('gui\btn_plname.png'));
  Obj.AddCaption('Zkuenosti (Voln/Celkov):', Fonts[FN_OPT], Point(0, 0));
  Obj.CanAct := false;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'Lab_nHP', Rect(50,90+35, 192,48), $FFFFFFAA, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('ivoty: ', Fonts[FN_PLSTAT], Point(10, 0),false);
  Obj.CanAct := false;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'Lab_nSPD', Rect(50,90+65, 192,48), $FFFFFFAA, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Rychlost: ', Fonts[FN_PLSTAT], Point(10, 0),false);
  Obj.CanAct := false;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'Lab_HP', Rect(220,90+35, 192,48), $FFFFBB88, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('ivoty: ', Fonts[FN_PLSTAT], Point(10, 0),false);
  Obj.CanAct := false;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'Lab_SPD', Rect(220,90+65, 192,48), $FFFFBB88, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Rychlost: ', Fonts[FN_PLSTAT], Point(10, 0),false);
  Obj.CanAct := false;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'Btn_HP', Rect(560,90+25, 192,38), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption(Format('+1  za  %d XP',[CS_HP]), Fonts[FN_PLSTAT], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'Btn_SPD', Rect(560,90+60, 192,38), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption(Format('+1  za  %d XP',[CS_SPD]), Fonts[FN_PLSTAT], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'Lab_Col', Rect(50,90+65+60, 192,48), $FFFFFFAA, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Vzhled: ', Fonts[FN_PLSTAT], Point(10, 0),false);
  Obj.CanAct := false;
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'Img_Pl', Rect(50+250,215-22, 152,76), $FFFFFFFF);
  Obj.SetUV(0.01,0.01,0.25,0.99);
  Obj.CanAct := false;
  Win.Add(Obj);
  UsedWins.PlImg := Obj;

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_imprev', Rect(300-48, 215-22+18, 32, 32), 0, TexMgr.GetTex('gui\btn_left.jpg'));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_imnext', Rect(300+152+8, 215-22+18, 32, 32), 0, TexMgr.GetTex('gui\btn_right.jpg'));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'Lab_nKills', Rect(50,240+35, 192,48), $FFFFFFAA, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Poet zabitch:', Fonts[FN_PLSTAT], Point(10, 0),false);
  Obj.CanAct := false;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'Lab_nDeaths', Rect(50,240+65, 192,48), $FFFFFFAA, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Poet mrt:', Fonts[FN_PLSTAT], Point(10, 0),false);
  Obj.CanAct := false;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'Lab_Kills', Rect(220,240+35, 192,48), $FFFFBB88, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('0 ', Fonts[FN_PLSTAT], Point(10, 0),false);
  Obj.CanAct := false;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'Lab_Deaths', Rect(220,240+65, 192,48), $FFFFBB88, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('0 ', Fonts[FN_PLSTAT], Point(10, 0),false);
  Obj.CanAct := false;
  Win.Add(Obj);





  Mgr.Add(Win);
  UsedWins.Playerswin := Win;
  Win := nil;
  ////////////////////////////////////////////////////



  //////////  INGAME MENU /////////////////
  Win := TGuiWin.Create(Mgr.Device, 'IngameMenu', Rect(80, 60, 640, 480), $EEFFDDDD, TexMgr.GetTex('screens\menu.jpg'));

  Obj := TGuiObj.Create(Mgr.Device, 'igLabel', Rect(320 + 32, 30, 256, 64), 0, TexMgr.GetTex('gui\btn_trans.png'));
  Obj.AddCaption('Konec', Fonts[FN_SCRLABEL], Point(0, 0));
  Obj.CanAct := false;
  Obj.Blend := bl_add;
  Win.Add(Obj);


  Obj := TGuiObj.Create(Mgr.Device, 'BTN_MMenu', Rect(MB_Left, 140, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Hlavn Menu', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_Win', Rect(MB_Left, 140 + 48 + 12, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Windows', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_EndMap', Rect(MB_Left, 140 + 60 + 60, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Opustit Misi', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_igOpt', Rect(MB_Left, 140 + 180, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Nastaven', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);

  Obj := TGuiObj.Create(Mgr.Device, 'BTN_imBack', Rect(MB_Left, 140 + 180 + 60, 192, 48), 0, TexMgr.GetTex('gui\btn_def.jpg'));
  Obj.AddCaption('Zpt', Fonts[FN_MEDBTN], Point(0, 0));
  Win.Add(Obj);


  Mgr.Add(Win);
  UsedWins.IngMenu := Win;
  Win := nil;
  ////////////////////////////////////////////////////




  List.Free;
end;




end.

